// add missing methods to string type.
String.prototype.trim = function()
{
    return this.replace(/^\s+|\s+$/g,"");
};
String.prototype.ltrim = function()
{
    return this.replace(/^\s+/,"");
};
String.prototype.rtrim = function()
{
    return this.replace(/\s+$/,"");
};

// ====================================== ICONs ====================================
var ws_icon = {};
ws_icon.type = {
		"default"   : { "icon" : { "image" : '/ord?file:^gui/themes/wattstopper/d.png', "position" : '-56px -19px' } },
		"BWSNetworkBridge"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-80px -16px' }, "targetSlot": "afterHours", "slot": "afterHours" },
		"BWSLMLS400"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -48px' } },
		"BWSLMLS500"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -48px' } },
		"BWSLMDC100"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-48px -32px' } },
		"BWSLMDM101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -32px' } },
		"BWSLMDW101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -32px' } },
		"BWSLMDW102"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -32px' } },
		"BWSLMPW101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -48px' } },
		"BWSLMPW102"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -64px' } },
		"BWSLMDX100"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-112px -32px' } },
		"BWSLMIO101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -48px' } },
		"BWSLMIO101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -48px' } },
		"BWSLMIO301"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-32px -48px' } },
		"BWSLMPC100"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-48px -64px' } },
		"BWSLMPL101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -64px' } },
		"BWSLMPL201"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-80px -80px' } },
		"BWSLMPL202"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-80px -80px' } },
		"BWSLMPL201DK": { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -128px' } },
		"BWSLMPL202DK": { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -128px' } },
		"BWSLMPX100"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-112px -64px' } },
		"BWSLMRC101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -80px' } },
		"BWSLMRC102"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-48px -80px' } },
		"BWSLMRC200"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -80px' } },
		"BWSLMRC211"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-80px -80px' } },
		"BWSLMRC212"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-96px -80px' } },
		"BWSLMRC213"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-112px -80px' } },
		"BWSLMRC221"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-96px -80px' } },
		"BWSLMRC222"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-96px -80px' } },
		"BWSLMRC311"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '0 -96px' } },
		"BWSLMRC312"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -96px' } },
		"BWSLMRC313"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-32px -96px' } },
		"BLMButton"   : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-80px -96px' } },
		"BWSLMSW101"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-80px -96px' } },
		"BWSLMSW102"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-112px -96px' } },
		"BWSLMSW103"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -112px' } },
		"BWSLMSW104"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-48px -112px' } },
		"BWSLMSW105"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-64px -112px' } },
		"BWSLMSW108"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-96px -112px' } },
		"BWSLMUC100"  : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '0 -128px' } },
		"BWSLMChannel": { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px 0' } , "targetSlot": "normalHours", "slot" : "out"},
		"BLILM"       : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -32px' } },
		"BLMRelay"    : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -16px' }, "targetSlot": "state", "slot" : "out" },
		"BLMLoad"     : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px -16px' }, "targetSlot": "level", "slot" : "level" },
		"BWSLIChannel": { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -128px' }, "targetSlot": "out", "slot" : "out" },
		"BWSLINB"     : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-32px -128px' } },
		"BNetworkGroup"   : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-16px -128px' } },
		"BWSSwitchedNumeric"   : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px 0px' } },
		"BWSGroupNumeric"   : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px 0px' } },
		"BWSGroupBoolean"   : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px 0px' } },
		"BGenericBooleanPoint" : { "icon" : { "image" : '/ord?file:^gui/images/map.png', "position" : '-128px 0' } , "targetSlot": "in10", "slot" : "out"}
		};

ws_icon.getSlotFromType = function(type)
{
	if(ws_icon.type[type]){
		if(ws_icon.type[type]["slot"]){
			return ws_icon.type[type]["slot"];
		}
	}
	return "";
};
ws_icon.getTargetSlotFromType = function(type)
{
	if(ws_icon.type[type]){
		if(ws_icon.type[type]["targetSlot"]){
			return ws_icon.type[type]["targetSlot"];
		}
	}
	return "";
};

ws_icon.getIconURL = function(type)
{
	if(ws_icon.type[type]){
		if(ws_icon.type[type]["icon"]){
			if(ws_icon.type[type]["icon"]["image"]){
				return ws_icon.type[type]["icon"]["image"];
			}
		}
	}
	return "";
};

ws_icon.getIconPosition = function(type)
{
	if(ws_icon.type[type]){
		if(ws_icon.type[type]["icon"]){
			if(ws_icon.type[type]["icon"]["image"]){
				return ws_icon.type[type]["icon"]["position"];
			}
		}
	}
	return "";
};

function jq(myid) { 
	   return '#' + myid.replace(/(:|\.)/g,'\\$1');
}

// ==================================== Startup and Timers ===========================================
var _ws = {}; // define _ws namespace

_ws.debug = false;
_ws.deviceManagement = false;
_ws.exportConfiguration = false; //BACNET EXPORT CONFIGURATION
_ws.groupData = null;
_ws.xml = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n";
_ws.defaultTimeout = 2000;
_ws.pollingLimit = 240;
_ws.deviceTimeout = 10000;
_ws.refreshTimeout = 2;
_ws.refreshCount = 0;

_ws.getRefreshTimeout = function()
{
	++_ws.refreshCount;
	val = (Math.pow(_ws.refreshCount/30,3)+_ws.refreshTimeout);
	if( val > _ws.pollingLimit) return _ws.pollingLimit;
	return val;
};

_ws.toggleDebug = function(){
	if( $("#messages:visible").length > 0 ){
		$('#messages').hide();
		_ws.debug=false;
	}else{
		$('#messages').show();
		_ws.debug=true;
	}
};
_ws.resetMainTimer = function(timeout)
{
	if(typeof(timeout) == 'undefined') timeout = 2;
	if(timeout < 2) timeout = 2;
	$("body").stopTime('mainTimer');
	$("body").everyTime(timeout+"s", 'mainTimer',function(){ _ws.mainLoop(); });
	_ws.refreshCount = 0;
};
_ws.pauseMainTimer = function()
{
	$("body").stopTime('mainTimer');
};
_ws.updateMainTimer = function(timeout)
{
	if(typeof(timeout) == 'undefined') timeout = _ws.getRefreshTimeout();
	if(timeout < 2) timeout = 2;
	$("body").stopTime('mainTimer');
	$("body").everyTime(timeout+"s", 'mainTimer',function(){ _ws.mainLoop(); });
	//if(_ws.debug)ws_util.logMessage("PollingLimit="+_ws.pollingLimit+" timeout="+timeout);
};

_ws.initialize = function()
{
	$("#statuswindow span").text("Starting Up...");
	$(document).ajaxError(function(e, xhr, settings, exception) {
		if(xhr.status != "0" && xhr.status != "200"){
			ws_util.statusMessage('ERROR('+xhr.status+'):'+ settings.url, 5000);
		}
	});
	$("#statuswindow span").text("Loading System...");
	_ws.loadSystem();
	$("#statuswindow span").text("Loading Config...");
	ws_config.loadTimeZones();
	ws_config.loadConfig();
	$('#configwin > div').hide();
	ws_sched.loadGroups();
	ws_grp.loadControlPoints();
	$('#configSystemInfo > label:eq(5)').next().load('/ord?file:^gui/version.html');
	$("body").everyTime("10s", 'mainTimer',function(){ _ws.mainLoop(); },1);
};

_ws.systemOffline = function(delay)
{
	if(typeof(delay) == 'undefined' || delay < 2){
		delay = 10;
	}
	$('#systemError').fadeIn(100);
//	$('#message-dialog').attr('title',"System Not Responding");
// 	$('#message-dialog > p > span:eq(1)').text("Waiting for system to respond...");
//	$("#message-dialog").dialog({
//		height:200,
//		width:400,
//		modal: false,
//		buttons: {
// 		}
//	});
 	$("body").oneTime(delay+"s",function(){
		$.ajax({
			url: "/gui/systemTime.xml",
			timeout: _ws.defaultTimeout,
			success: function(data){
				$('#systemError').fadeOut(100);
 				//$('#message-dialog').dialog('close');
			},
			error: function(){
				_ws.systemOffline((_ws.defaultTimeout /1000)+1);
			}
		});
	});
};

_ws.waitForStartup = function(delay)
{
	if(typeof(delay) == 'undefined' || delay < 2){
		delay = 20;
	}
	$('#message-dialog').attr('title',"Server Rebooting");
 	$('#message-dialog > p > span:eq(1)').text("Waiting for server to start...");
	$("#message-dialog").dialog({
		height:200,
		width:400,
		modal: true,
		buttons: {
 		}
	});
	_ws._waitForStartup(delay);
};

_ws._waitForStartup = function(delay)
{
 	$("body").oneTime(delay+"s",function(){
		$.ajax({
			url: "/gui/systemTime.xml",
			timeout: _ws.defaultTimeout,
			success: function(data){
			 	$('#message-dialog > p > span:eq(1)').html('System Started. <a href="/ord?file:^gui/index.html">Click to Load GUI</a>');
				window.location = "/ord?file:^gui/index.html";
			},
			error: function(){
				_ws._waitForStartup(3);
			}
		});
	});
};

_ws.mainLoop = function()
{
	var hash = window.location.hash;
	var selected = parseInt(hash.charAt(hash.length -1)) - 1 || 0;
	//ws_util.statusMessage(selected,2000);
	switch(selected){
	case 0: // main tab
		ws_config.updateTime();
		break;
	case 1: // device tab
		_ws.updateMainTimer();
		var deviceSelected = false;
		var currID = $('#device').attr('deviceID');
		ws_device.updateDevice();
		break;
	case 2: // group tab
		break;
	case 3: // schedule tab
		break;
	case 4: // config tab
		_ws.updateMainTimer();
		ws_config.refresh();
		break;
	case 5: //technician tab
		break;
	default:
		alert("bad tab selected: " + selected);
	}
};

_ws.tabSelected = function(event,ui)
{
	var hash = window.location.hash;
	var selected = parseInt(hash.charAt(hash.length -1)) - 1;
	_ws.refreshCount = 0;
	
	switch(selected){
	case 0: // main tab
		_ws.resetMainTimer(60);
		ws_config.updateTime();
		break;
	case 1: // device tab
		// if someone has been rediscovering devices, then reload the tree
		// TODO Server could report last discovery time. We could check that and refresh
		// accordingly
		if(ws_config.discovering){
			ws_config.discovering = false;
			ws_device.loadDevices();
		}else{
			if(ws_device.needLoading){
				ws_device.loadDevices();
			}
		}
		_ws.resetMainTimer();
		break;
	case 2: // group tab
		_ws.resetMainTimer(60);
		break;
	case 3: // schedule tab
		_ws.resetMainTimer(60);
		ws_sched.loadGroups();
		break;
	case 4: // config tab
		_ws.resetMainTimer();
		ws_config.select();
		ws_config.logStreaming($("#logStreamingEnabled").is(':checked'));
		break;
	case 5: //exportable items tab
		ws_technicianpages.loadExportableItems();
		break;
	}
};

// Administration flag to enable administrative features.
_ws.admin = false;

_ws.loadSystem = function()
{
	$.get("/gui/system.xml", function(data){
		if( $(data).find('adminPermission').text() == 'true') _ws.admin = true;

		if(_ws.admin){
			$('#configlist option').attr('disabled',false);
			$('#configlist option').show();
		}
		var user = $(data).find('user');
		fullname = $(user).find('fullName').text();
		if(fullname == "")fullname = $(user).find('name').text();
		$('#logininfo span').text(fullname);
		$('#configUser input:eq(0)').val($(user).find('name').text());
		$('#configUser input:eq(1)').val($(user).find('fullName').text());
		$('#configUser select:first').val($(user).find('permissions').text());
		$('#configUser input:eq(2)').val($(user).find('email').text());
		$('#current_time').text($(data).find('time').text());
		var timestamp = $(data).find('timestamp').text();
		// alert(timestamp);
		re = /(\d\d\d\d)(\d\d)(\d\d)T(\d\d):(\d\d):(\d\d)/;
		var date = timestamp.replace(re,"$2/$3/$1");
		var hour = timestamp.replace(re,"$4") * 1;
		var min = timestamp.replace(re,"$5") * 1;
		var type = hour < 12 ? "am" : "pm";
		if(hour > 12) hour -= 12;
		if(hour == 0) hour = 12;
		// alert(type+" "+hour+" "+date+" "+min+" "+hour);
		$('#configTime .datepicker3').val(date);
		var time = $('#configTime > label:eq(1)').next();
		$(time).find('select:eq(0) option[value="'+hour+'"]').attr('selected','selected');
		$(time).find('select:eq(1) option[value="'+min +'"]').attr('selected','selected');
		$(time).find('select:eq(2) option[value="'+type+'"]').attr('selected','selected');
		$('#configSystemInfo > label:eq(0)').next().text($(data).find('stationName').text());
		$('#configSystemInfo > label:eq(1)').next().text($(data).find('hostid').text());
		ws_config.setPlatformInfo($(data).find('platform'));
		$('#configSystemInfo > label:eq(2)').next().text($(data).find('platform > niagaraVersion').text());
		$('#configSystemInfo > label:eq(6)').next().text($(data).find('moduleVersion').text());
		if($(data).find('en0').length > 0 && $(data).find('en1').length > 0){
			ws_config.setNetworkInfo($(data).find('en0'),$(data).find('en1'));
		}
		_ws.setBACnetValues($(data).find('bacnet').first());
	});
};

_ws.setBACnetMSTPValues = function(bnet, values)
{
	if($(values).length < 1){
		$(bnet ).parent().parent().hide();
		return;
	}
	var baud = $(values).find('baudRate').text();
	$(bnet).find(' label:eq(0) > input:eq(0)').attr('checked',$(values).find('enabled').text() == 'true');
	$(bnet).find(' label:eq(1)').next().val($(values).find('networkNumber').text());
	$(bnet).find(' label:eq(2)').next().find('option[value="'+baud+'"]').attr('selected','selected');
	$(bnet).find(' label:eq(3) + input').first().val($(values).find('maxMaster').text());
	$(bnet).find(' label:eq(4) + input').first().val($(values).find('address').text());
};

function sortNumber(a, b)
{
return a - b;
}

_ws.getDnets = function(){
	var dnets = new Array();
	var allnets = $('#allnets').is(':checked');
	$('#dnets input').each(function(){
		if($(this).is(':checked') || allnets){
			dnets.push($(this).val());
		}
	});
	return dnets;
};

_ws.setBACnetValues = function(bacnet){
	if ($(bacnet).find('routing:first').text() == 'true') { //9/14/2012 - No longer a checkbox, we'll just update the text on the screen
		$('#configBACnet > label:eq(0)').text("BACnet Routing: enabled");
	} 

	var ip = $(bacnet).find('ipPort').first();
	$('#bacnetip label:eq(0) > input:eq(0)').attr('checked',$(ip).find('enabled').text() == 'true');
	$('#bacnetip label:eq(1)').next().val($(ip).find('networkNumber').text());
	$('#bacnetip label:eq(2)').next().val($(ip).find('udpPort').text());
	var local = $(bacnet).find('local').first();
	$('#localdevice label:eq(0)').next().val($(local).find('id').text());
	$('#localdevice label:eq(1)').next().val($(local).find('description').text());
	$('#localdevice label:eq(2)').next().val($(local).find('location').text());
	_ws.setBACnetMSTPValues($('#bacnet1'), $(bacnet).find('MstpPort1').first());
	_ws.setBACnetMSTPValues($('#bacnet2'), $(bacnet).find('MstpPort2').first());
	_ws.setBACnetMSTPValues($('#bacnet3'), $(bacnet).find('MstpPort3').first());

	// SET BACNET NETWORKS TO DISCOVER
	var selnode = $(bacnet).find('netsSelected').first();
	var snets = new Array();
	var allnode = $(selnode).find('all').first();
	var all = false;
	if($(allnode).text() == "true")all = true;
	$('#allnets').attr('checked',all);
	$(selnode).find('net').each(function(){
		snets.push($(this).text());
	});
	if(snets.length < 1){
		if($('#bacnet1  label:eq(0) > input:eq(0):checked').length > 0){
			snets.push($('#bacnet1  label:eq(1)').next().val());
		}
		if($('#bacnet2  label:eq(0) > input:eq(0):checked').length > 0){
			snets.push($('#bacnet2  label:eq(1)').next().val());
		}
		if($('#bacnet3  label:eq(0) > input:eq(0):checked').length > 0){
			snets.push($('#bacnet3  label:eq(1)').next().val());
		}
	}
	var netsnode = $(bacnet).find('nets').first();
	var nets = new Array();
	$(netsnode).find('net').each(function(){
		nets.push($(this).text());
	});
	nets.sort(sortNumber); // $.inArray(value,array) > -1
	// create checkboxes for destination networks
	var dnets=$('#dnets');
	$(dnets).empty();
	$.each(nets, function(i, v){
		if($.inArray(v,snets)>-1){
			$(dnets).append('<label><input type="checkbox" checked="checked" value="'+v+'"/> '+v+'</label>');
		}else{
			$(dnets).append('<label><input type="checkbox" value="'+v+'"/> '+v+'</label>');
		}
	});

};

_ws.requestReboot = function(){
	$('#message-dialog').attr('title','Reboot Request');
 	$('#message-dialog > p > span:eq(1)').text("Reboot System?\nNOTE: will take up to 4 minutes.");
 	$(function() {
 		$("#message-dialog").dialog({
 			height:200,
 			width:400,
 			modal: true,
 			buttons: {
	 			"Yes": function() {
		 			$(this).dialog('close');
					$.get('/gui?q=rebootSM', function(data) {
						$('.result').html(data);
					});
		 		},
		 		"No" : function() {
		 			$(this).dialog('close');
		 		}
	 		}
 		});
 	});
};

// ============================================ Utilities =============================

var ws_util = {}; // ws_util namespace

ws_util.objectContains = function(object,name,delimeter) {
	var text = ""
	for (var prop in object) { //should only be one
		if (object.hasOwnProperty(prop)) {
			var s  = prop.toString().split(delimeter);
			if (s[0] == name)
				return object[prop].toLowerCase();
		}
	}
	return null;
};

ws_util.numSel = function(start,end, name, id)
{
	if(start < -100 || end > 1000) return;
	document.write('<select');
	if(typeof(id) != "undefined" && id != ""){
		document.write(' id="'+id+'"');
	}
	if(typeof(name) != "undefined" && name != ""){
		document.write(' name="'+name+'"');
	}
	document.write('>');
	for(var i=start;i<end;i++){document.write('<option value="'+i+'">'+(i<10?'0':'')+i+'</option>');}
	document.write('</select>');
};

ws_util.pad = function(number, length) {

    var str = '' + number;
    while (str.length < length) {
        str = '0' + str;
    }
    return str;
};

ws_util.handleResult = function(data,textStatus,successMsg,failMsg,handlefunc){

	var result = false;
	if(typeof(textStatus) != 'undefined'){
		result = textStatus.toLowerCase() == 'success';
	}
	//ws_util.logMessage(textStatus+successMsg+failMsg);
	if ($(data).find('responseCode').length > 0){
		var resultCode = $(data).find('responseCode').text();
		if(typeof(resultCode) != 'undefined'){
			if(resultCode == "0" || resultCode == "200") result = true;
		}
	}
	if(typeof(handlefunc)=="function"){
		handlefunc(result);
	}
	if(result){
		if(successMsg != ''){
			ws_util.statusMessage(successMsg);
		}
	}else{
		if(failMsg != ''){
			ws_util.statusMessage("ERROR"+ws_util.getResultString(data)+"<br/>"+failMsg,8000);
		}
	}
};

ws_util.get = function(aurl,successFunc,failFunc,atimeout){
	if(typeof(atimeout)=="undefined")atimeout=_ws.defaultTimeout;
	if(typeof(failFunc != "function")){
		failFunc=function(){_ws.systemOffline();};
	}
	$.ajax({
		url: aurl,
		timeout: atimeout,
		statusCode: {
			  404: function() {
			    $("#response").html('Could not contact server.');
			  },
			  500: function() {
			    $("#response").html('A server-side error has occurred.');
			  }
		},
		success: successFunc,
		error: failFunc
	});
};

ws_util.logMessage = function(msg){
	if(_ws.debug) $("#messages").append(msg+"\n");
};

ws_util.statusMessage = function(msg,delay){
	if(typeof(delay) == "undefined"){
		delay = 1000;
	}
	$("#statuswindow").stop();
	$("#statuswindow").fadeTo(0,1);
	$("#statuswindow span").text(msg);
	$("#statuswindow").fadeOut(delay);
	if(_ws.debug) $("#messages").append(msg+"\n");
};

ws_util.getResultString = function(data){
	var result='';
	$(data).find('responseCode').each(function(){
		result= "("+$(this).text()+") "+$(data).find('responseMessage').text();
	});
	return result;
};

ws_util.messageDialog = function(title, text){
	$('#message-dialog').attr('title',title);
 	$('#message-dialog > p > span:eq(1)').text(text);
 	$(function() {
 		$("#message-dialog").dialog({
 			height:200,
 			width:400,
 			modal: true,
 			buttons: {
	 			"OK": function() {
		 			$(this).dialog('close');
		 		}
	 		}
 		});
 	});
};

ws_util.buildenum = function(values){
 var a = new Array();
 if(values){
  v = values;
  items=v.split(',');
  if(items.length > 1){
   for(var i=0;i < items.length ;i++){
    var na = ws_util.rangeorassoc(items[i]);
    for(var j=0;j<na.length;j++){
     if(na[j]) a[j]=na[j];
    }
   }
  }else{
   a= ws_util.rangeorassoc(v);
  }
 }
 return a;
};

ws_util.rangeorassoc = function(t){
 q_range = new Array();
 // alert(t);
 r_range = t.split('..');
 if(r_range.length == 2){
  for(var i_range=r_range[0]; i_range <= r_range[1]; i_range++){
   q_range[i_range]=i_range;
  }
 }else{
  r_range = t.split('=');
  if(r_range.length == 2){
   q_range[new String(r_range[0])]=new String(r_range[1]);
  }else{
   q_range[t]=t;
  }
 }
 return q_range;
};

ws_util.selectOptionsFromValues = function(values, current){
 var a = ws_util.buildenum(values);
 var options = '';
 for(var key in a){
  options+="<option ";
  if(key==current)options+=' selected="selected" ';
  options+= ' value="'+key+'">'+a[key]+'</option>\n';
 }
 return options;
};

ws_util.buildenumbuttons = function(a, handle, name){
	var btn1 = '';
	var key = '';
	for(key in a){
		if(btn1 == ''){
			btn1='<input type="submit" value="'+key+'" onclick="ws_config.updateValue(\''+handle+'\',\''+name+'\',\''+a[key]+'\');"/>';
		}
	}
	var btnlast='<input type="submit" value="'+key+'" onclick="ws_config.updateValue(\''+handle+'\',\''+name+'\',\''+a[key]+'\');"/>';
	return btn1 + bntlast;
};

ws_util.gotoExternalLink = function(){
	if($('#externalRefs').val() != ''){
		if($('#externalRefs :selected').attr('window')== "true"){
			window.open($('#externalRefs').val());
		}else{
			window.location = $('#externalRefs').val();
		}
	}
};

ws_util.post = function(xml,successMsg,failMsg,handlefunc){
	$.post( '/gui',
		{'xml':xml},
		function(data,textStatus, xmlRequest){
			ws_util.handleResult(data,textStatus,successMsg,failMsg,handlefunc);
		},
		'xml'
	);
};

// ================================= Groups ==============================
var ws_grp = {}; // group namespace

ws_grp.linktype = {
		"NormalAfterHours" : {
			"BWSNetworkBridge" : {"targetSlot":"afterHours","slot":"afterHours" },
			"BWSLMChannel" : {"targetSlot": "normalHours", "slot" : "out"},
			"BGenericBooleanPoint" : { "targetSlot": "in10", "slot" : "out"},
			"BLMRelay"  : { "targetSlot": "state", "slot" : "out" },
			"BLMLoad"   : { "targetSlot": "level", "slot" : "level" },
			"BWSLIChannel"   : { "targetSlot": "out", "slot" : "out" }
		},
		"Level" : {
			"BLMLoad"   : { "targetSlot": "level", "slot" : "level" }
		}
};

$("#Groups").ready(function() {
	ws_grp.loadGroupList();
	ws_grp.setupListeners();
});

ws_grp.submitEnabled = function(enabled) {
	if (enabled) {
		$("#gsavediv input").attr('disabled',false);
	} else {
		$("#gsavediv input").attr('disabled','disabled');
	}

};

ws_grp.regexPatterns = {
		'validname' : { 'regex': new RegExp("^([^0-9 ]+)([a-zA-Z0-9]{0,31})$"), 'message': 'Valid chars are a-z, A-Z, 0-9. Length 5-32 characters. Cannot start with a number.'},
		'validdevicename' : { 'regex': new RegExp("^([\\w\\s]{1,32})$"), 'message': 'Valid chars are any word character. Length 1-32 characters.'}
		//'nostartdigits' : { 'regex': new RegExp('^\\d'), 'message': 'Field cannot start with a digit.' },
	    //'nospaces' : {'regex': new RegExp(' '), 'message': 'No spaces allowed in field.' }
					};

ws_grp.matchAnyErrorPattern = function(patterns,text,length) {
	
	if (text.length > length) {
		return "Too long. Limit is " + length + ".";
				}
	for (pattern in patterns) {		
		var regex = ws_grp.regexPatterns[patterns[pattern]].regex;
		if (regex.test(text)) {
			return ws_grp.regexPatterns[patterns[pattern]].message;
					}
				}
	return "";
};
ws_grp.checkGroupName = function() {
	var text = $("#groupName").val();
	//var regex = new RegExp("^([a-zA-Z]+)([0-9a-zA-Z_]*)");
	var regex = ws_grp.regexPatterns.validname.regex;
	if (regex.test(text)) {
		$("#groupNameError").empty();
		ws_grp.submitEnabled(true);		
	} else {			
		var errorText = ws_grp.regexPatterns.validname.message;
		$("#groupNameError").text(errorText);	
		ws_grp.submitEnabled(false);
	}

};

ws_grp.setupListeners = function()
{
	//Group Name
	$("#groupName").keyup(function(event) {		
		ws_grp.checkGroupName();
	});
};

ws_grp.loadGroupList = function()
{
	var shandle = $('#grouptable tr.groupselected').attr('handle_id');
	$.get("/gui/groups.xml",function(data){
		_ws.groupData = data;
		var groups = '';
		$(data).find('group').each(function(){
			var theclass = $(this).attr('t');
			var description = $(this).find('description').text();
			var handle = $(this).find('handle').text();
			var name = $(this).find('name').text();
			var action = $(this).find('actionType').text();
			if(action == "networkID")return; //NOTE Some groups in the list are Network IDs for buttons. Not really groups.
			var type = $(this).find('status').text();
			groups+="<tr class=\"grouplisting\" handle_id=\""+handle+"\" title=\""+description+"\">";
			groups+="<td width=\"55%\">"+name+"</td>";
			groups+="<td width=\"20%\" align=\"center\">"+action+"</td>";
			groups+="<td width=\"25%\" align=\"center\">"+status+"</td>";

		});
		$("#grouptable tbody").html(groups);
		$('#grouptable tr').click(function() {
			   // Load group data
			// alert("group clicked");
		   ws_grp.selectGroup(this.getAttribute('handle_id'));
		});
		if(shandle){
			$('#grouptable tr[handle_id="'+shandle+'"]').click();
	}
		ws_sched.setGroupList(ws_sched.getActionType(),true);
	});
};

ws_grp.loadControlPoints = function(type)
{
	if(typeof(type)== "undefined") type = "Rooms";
	var url = "/gui/controlPoints.json?type="+encodeURIComponent(type);
	$('#pointTree').jstree('destroy');
	ws_util.statusMessage("Loading Point Tree...",10000);
	// $("#devicetree").jstree("set_theme","apple");
	$(function () {
		$.jstree._themes = "/ord?file:^gui/themes/";
		$("#pointTree").bind("loaded.jstree", function() {
			ws_util.statusMessage("Points Loaded...");
		}).jstree({
			core : { "animation" : 0 },
			"json_data" : {
				"ajax" : {
					"url" : url
				},
				"xsl" : "nest"
			},
			"dnd" : {
				"drop_target" : ".group-drop",
				"drag_target" : false,
				"drop_finish" : function (data) {
					ws_grp.dropGroup(data);
				},
				"drop_check" : function (data) {
					if(data.r.hasClass("group-drop")){
						return ws_grp.checkGroupTypeForAdd(data.o);
						// return true;
					}else{
						return false;
					}
					if(data.r.attr("id") == "phtml_1") {
						return false;
					}
					return {
						after : false,
						before : false,
						inside : true
					};
				}
			},
			"crrm" : {
				"move" : {
	                "check_move" : function (m) {
						return false;
	}
	}
			},
			"themes" : {
				"theme" : "wattstopper",
				"dots" : true,
				"icons" : true
			},
			"ui" : {
				"select_limit" : 1,
				"select_multiple_modifier" : "alt",
				"selected_parent_close" : "select_parent"
			},
			"types" : {
				"max_depth" : -2,
				"max_children" : -2,
				"valid_children" : "all",
				"type_attr" : 'ntype',
				"types" : ws_icon.type
			},
			"plugins" : [ "types", "themes", "ui", "crrm", "json_data", "dnd" ]
		});
	});
};

// ================================ Group ==================================

ws_grp.setGroupType = function()
{
	var type = $('#gtype').val();
	var currentType = $('#thegroup').attr('ntype');
	if(currentType != ""){
		if(type == currentType) return;
		var selected = $('#selectedPoints option');
		if(selected.length > 0){
			$('#selectedPoints').empty();
		}
	}
	ws_grp.loadControlPoints(type);
	$('#thegroup').attr('ntype', type);
};

ws_grp.copySelection = function()
{
	var node = $('#pointTree').jstree('get_selected');
	if($(node).length == 1){
		if(ws_grp.checkGroupTypeForAdd(node)){
			// alert($(node).attr('id'));
			ws_grp.addGroupItem(node);
		}else{
			ws_util.statusMessage("Invalid Type");
	}
	}
};

ws_grp.removeSelection = function()
{
	$('#selectedPoints :selected').detach();
};

ws_grp.dropGroup = function(data)
{
	// alert(data.r.attr("id"));
	// alert(data.o.attr("id")+" "+data.o.attr("title")+"
	// "+data.o.attr('ntype'));
	// alert(getIconPosition(data.o.attr('ntype')));
	// ws_grp.addGroupItem(data.o.attr('ntype'),data.o.attr("id"),
	// data.o.attr("title"));
	ws_grp.addGroupItem(data.o);
};

ws_grp.dropMatcher = { //Update this with future drop choices
	"Rooms": 'BWSNetworkBridge',
	"Channels": 'BWSLMChannel',
	"Relays": 'BLMRelay',
	"Loads": 'BLMLoad',
	"SwitchedLoads": 'BLMLoad',
	"CustomBOs": 'BGenericBooleanPoint'
};

ws_grp.checkGroupTypeForAdd = function(node)
{
	var type = $(node).attr('ntype');	
	var gtype = $('#gtype').val();
	var object_type = ws_grp.dropMatcher[gtype];
	if (object_type) {	
		return $(node).find('[ntype="' + object_type + '"]').length > 0 || type == object_type;
	} else {
		return false;		
	}
};

ws_grp.addGroupItem = function(original_node)
{
	if(original_node){
		if(typeof(original_node) == "object"){
			//we need to get all the items associated with the item dropped since it might be a folder
			var gtype = $('#gtype').val();
			var object_type = ws_grp.dropMatcher[gtype];		
			var sub_nodes = $(original_node).find('[ntype="' + object_type + '"]');
			var type = $(original_node).attr('ntype');
			if (type == object_type) { //handle the case where we are just adding one item of the correct type
				sub_nodes.push(original_node);
			}
			$.each(sub_nodes, function(index, node) {
				found = $('#selectedPoints option[value="'+$(node).attr("id")+'"]');
				if (found.length <= 0) { //then this one doesn't exist already, add it
					type = $(node).attr('ntype');
					var slot = ws_icon.getSlotFromType(type);
					var targetSlot = ws_icon.getTargetSlotFromType(type);
					var heir = ws_grp.getNodeHeirarchy(node);
					// var name = ws_grp.getNodeName(name);
					var option = '<option value="'+$(node).attr("id")+'" type="'+type+'" slot="'+slot+'" targetSlot="'+targetSlot+'" title="'+$(node).attr("title")+'">'+heir+'</option>';
					$('#selectedPoints').append(option);					
				}
			});
			
//			if(found.length > 0){
//				ws_util.statusMessage("already exists");
//			}else{
//				var type = $(node).attr('ntype');
//				var slot = ws_icon.getSlotFromType(type);
//				var targetSlot = ws_icon.getTargetSlotFromType(type);
//				var heir = ws_grp.getNodeHeirarchy(node);
//				// var name = ws_grp.getNodeName(name);
//				var option = '<option value="'+$(node).attr("id")+'" type="'+type+'" slot="'+slot+'" targetSlot="'+targetSlot+'" title="'+$(node).attr("title")+'">'+heir+'</option>';
//				$('#selectedPoints').append(option);
//			}
		}
	}
};

ws_grp.getNodeName = function(node)
{
	var name = $(node).find('a:first').text();
	if(name.charCodeAt(0) == 160){
		name = name.substring(1);
	}
	return name;
};

ws_grp.getNodeHeirarchy = function(node)
{
	var names = ws_grp.getNodeName(node);
	$(node).parents("li.jstree-last, li.jstree-closed, li.jstree-open").each(function(){
		names = ws_grp.getNodeName(this)+"/"+names;
			});
	return names;
};
ws_grp.getLinkText = function(obj)
{
	var link = "";
	link += "<link>";
	link += "<name><![CDATA["+$(obj).text()+"]]></name>";
	link += "<handle>"+$(obj).val().substring(1)+"</handle>";
	link += "<slot>"+$(obj).attr('targetSlot')+"</slot>";
	link += "</link>";
	return link;
};

ws_grp.getGroupXML = function()
{
	var type = $('#gfld2 select:eq(0) :selected').val();
	var aclass = '';
	if(type == "Rooms" || type == "Channels" || type == "Relays" || type == "CustomBOs"){
		 aclass="BWSGroupBoolean";
	}else if(type == "Loads"){
		 aclass="BWSGroupNumeric";
	}else if(type == "SwitchedLoads"){
		 aclass="BWSSwitchedNumeric";
		}
	var xml = _ws.xml;
	xml+= '<group t="com.wattstopper.component.'+aclass+'">\n';
	var handle = $('#grouptable tr.groupselected').attr('handle_id');
	if(typeof(handle) != "undefined"){
		xml+='<handle>'+handle+'</handle>\n';
		}
	xml+= '<name><![CDATA['+$('#groupName').val()+']]></name>\n';
	xml+= '<type>'+type+'</type>';
	if(type == "Rooms"){
		var link = "";
		$('#selectedPoints option[slot="out"]').each(function(){
			link += ws_grp.getLinkText(this);
	});
		xml+= "<out>"+link+"</out>";
		link = "";
		$('#selectedPoints option[slot="afterHours"]').each(function(){
			link += ws_grp.getLinkText(this);
	});
		xml+= "<afterHours>"+link+"</afterHours>";
		link = "";
		$('#selectedPoints option[slot="level"]').each(function(){
			link += ws_grp.getLinkText(this);
});
		xml+= "<level>"+link+"</level>";
	}else if(type == "Loads"){
		var link = "";
		$('#selectedPoints option[slot="out"]').each(function(){
			link += ws_grp.getLinkText(this);
			});
		$('#selectedPoints option[slot="level"]').each(function(){
			link += ws_grp.getLinkText(this);
		});
		xml+= "<out>"+link+"</out>";
	}else if(type == "SwitchedLoads"){
		var link = "";
		$('#selectedPoints option[slot="out"]').each(function(){
			link += ws_grp.getLinkText(this);
		});
		xml+= "<out>"+link+"</out>";
		var link = "";
		$('#selectedPoints option[slot="level"]').each(function(){
			link += ws_grp.getLinkText(this);
		});
		xml+= "<level>"+link+"</level>";
	}else if(type == "Channels" || type == "Relays" || type == "CustomBOs"){
		var link = "";
		$('#selectedPoints option[slot="out"]').each(function(){
			link += ws_grp.getLinkText(this);
		});
		xml+= "<out>"+link+"</out>";
	}
	xml+="</group>";
	$('#messages').text(xml);
	return xml;
};

ws_grp.doCreateGroup = function(check){
	if(typeof(check) == "undefined") check = true;
	var handle = $('#grouptable tr.groupselected').attr('handle_id');
	if(handle){
		if(check == true){
			ws_grp.doCheckGroupForChanges(ws_grp.doCreateGroup);
			return;
		}
		$('#grouptable tr[handle_id="'+handle+'"]').removeClass('groupselected');
	}
	ws_grp.initGroup();	
	$("#grouploading").hide();
	$("#thegroup").show();
	ws_grp.checkGroupName(); //this comes last because it disables the submit button preventing a creation of a group w/ an invalid name.
};

ws_grp.doDeleteGroup = function(check){
	if(typeof(check) == "undefined") check = true;
	var handle = $('#grouptable tr.groupselected').attr('handle_id');
	if(typeof(handle) == "undefined"){
		ws_util.messageDialog("Error","No group selected");
		return;
	}
	var name = $('#grouptable tr.groupselected td:eq(0)').text();
	if(check){
		$('#dlg-delete-group').attr('title','Delete Group - '+name);
		$(function() {
			$("#dlg-delete-group").dialog({
				resizable: false,
				height:200,
				width:450,
				modal: true,
				buttons: {
					'Delete': function() {
						ws_grp.doDeleteGroup(false);
						$(this).dialog('close');
					},
					'Cancel': function() {
						$(this).dialog('close');
					}
				}
			});
		});
	}else{
		$.get('/gui?q=remove&handle='+handle,function(data){ alert('Group Deleted'); });
		ws_grp.loadGroupList();
		$('#devicetree').jstree('refresh',$('#dev_grps'));
	}
};

ws_grp.doCopyGroup = function(check){
	if(check == null) check = true;
	var handle = $('#grouptable tr.groupselected').attr('handle_id');
	if(handle){
		if(check){
			ws_grp.doCheckGroupForChanges(ws_grp.doCopyGroup);
			return;
		}
		$('#grouptable tr[handle_id="'+handle+'"]').removeClass('groupselected');
	}else{
		ws_util.messageDialog("Error","No group selected");
		return;
	}
	ws_grp.loadGroup(handle,true);
};

ws_grp.doSaveGroup = function()
{
	if($('#groupName').val() == ""){
		ws_util.messageDialog("Save Group","ERROR: Group must have name");
		return false;
	}
	ws_util.statusMessage("Saving Group...",5000);
	var xmlData = ws_grp.getGroupXML();
	ws_util.post(xmlData,"Saved","Save Failure",function(result){
		if(result){
			ws_grp.loadGroupList();
			$('#devicetree').jstree('refresh',$('#dev_grps'));
			$('thegroup').hide();
		}
	});

	return true;
};

ws_grp.doCheckGroupForChanges = function(callback){
 if (typeof(callback) != "function") callback = false;
	var handle = $('#grouptable tr.groupselected').attr('handle_id');
 if(handle){
  // TODO check to see if values have actually been changed

  $(function() {
			$("#dlg-save-group").dialog({
    resizable: false,
    height:200,
    modal: true,
    buttons: {
    'Yes': function() {
						if(ws_grp.doSaveGroup()){
     if(callback) callback(false);
    }
    $(this).dialog('close');
   },
   'No': function() {
    if(callback) callback(false);
    $(this).dialog('close');
   },
   Cancel: function() {
    $(this).dialog('close');
   }
   }
   });
  });
 }else{
  callback(false);
 }
};

ws_grp.selectGroup = function(handle_id)
{
	var oldhandle = $('#grouptable tr.groupselected').attr('handle_id');
 if(oldhandle){
  if(oldhandle != ''){
   if(oldhandle == handle_id){
    // alert("don't do anything");
    return;
   }
   // check for changes?
   // TODO Ask for save/discard/cancel
			$('#grouptable tr[handle_id="'+oldhandle+'"]').removeClass('groupselected');
  }
 }
	$('#grouptable tr[handle_id="'+handle_id+'"]').addClass('groupselected');
	ws_grp.loadGroup(handle_id);
};

ws_grp.initGroup = function()
{
	$("#groupName").val("");
	$("#gtype option[value='Rooms']").attr('selected','selected');
	ws_grp.setGroupType();
	$("#selectedPoints").html("");
};

ws_grp.loadGroup = function(handle_id, clearName)
{
	if(typeof(clearName)== "undefined") clearName = false;
	$("#thegroup").hide();
	$("#grouploading").show();
	ws_grp.initGroup();
	$('#selectedPoints option').detach();
	$.get("/gui/groups.xml?handle="+handle_id, function(xml){
		var name = $(xml).find('name:first').text();
		var type = $(xml).find('type:first').text();
		if(type == "Normal/After Hours") type = "Rooms";
		var gtype = $("#gtype option[value='"+type+"']");
		if(gtype.length == 0){
			gtype = $("#gtype option[value='Rooms'");
		}
		$(gtype).attr('selected','selected');
		ws_grp.setGroupType();
		ws_grp.groupAddLinks($(xml).find("afterHours"),"afterHours");
		ws_grp.groupAddLinks($(xml).find("out"),"out");
		ws_grp.groupAddLinks($(xml).find("level"),"level");
		if(clearName){
			$("#groupName").val("");
	}else{
			$("#groupName").val(name);
	}
		$("#grouploading").hide();
		$("#thegroup").show();
	});
};

ws_grp.groupAddLinks = function(xml, sourceSlot)
{
	if($(xml).length < 1 ) return;
	// var sourceSlot = $(xml).nodeName;
	$(xml).find('link').each(function(){
		var handle = $(this).find('handle').text();
		var name   = $(this).find('name').text();
		var targetSlot   = $(this).find('slot').text();
		var descr   = $(this).find('descr').text();
		if(descr == "")descr = name;
		var option = '<option value="g'+handle+'" slot="'+sourceSlot+'" targetSlot="'+targetSlot+'" title="'+name+'">'+descr+'</option>';
		$('#selectedPoints').append(option);
	});
};
// ================================ Schedules =============================
var ws_sched = {}; // schedule namespace

ws_sched.actionGroupTypes = {
		"Normal/After Hours" : [ "Rooms", "Channels", "Relays", "networkID", "CustomBOs", "SwitchedLoads" ],
		"Set Level" : [ "Loads" ]
};

$("#Schedules").ready(function() {
	ws_sched.loadScheduleList();
});

ws_sched.loadScheduleList = function(initScheduleForm)
{
	if(initScheduleForm === "undefined"){
		iniScheduleForm = true;
	}
	var shandle = $('#scheduletable tr.scheduleselected').attr('handle_id');
	$.get("/gui/schedules.xml", function (data){
		var schedules = '';
		$(data).find('schedule').each(function(){
			var description = $(this).find('description').text();
			var handle = $(this).find('handle:first').text();
			var name   = $(this).find('name:first').text();
			var action = $(this).find('action:first').text();
			var type   = $(this).find('type:first').text();
			var start  = $(this).find('start:first').text();
			var end    = $(this).find('end:first').text();
			var group  = "";
			$(this).find('group').each(function(){
				if(group != "")	group += ', ';
				group += $(this).find('name').text();
			});
			schedules+="<tr class=\"schedulelisting\" handle_id=\""+handle+"\" title=\""+description+"\">";
			schedules+="<td width=\"35%\">"+name+"</td>";
			schedules+="<td width=\"17%\" align=\"center\">"+action+"</td>";
			schedules+="<td width=\"8%\" align=\"center\">"+type+"</td>";
			schedules+="<td width=\"10%\" align=\"center\">"+start+"</td>";
			schedules+="<td width=\"10%\" align=\"center\">"+end+"</td>";
			schedules+="<td width=\"20%\" class=\"hideover\" title=\""+group+"\">"+(group.length > 20?group.substr(0,15)+'...':group)+"</td></tr>";
		});
		$("#scheduletable tbody").html(schedules);
		if(initScheduleForm)ws_sched.initSchedule();
		// Handle click of schedule on the list.
		$('#scheduletable tr').click(function() {
			// alert(this.getAttribute('handle_id'));
			// Load schedule data
			ws_sched.selectSchedule(this.getAttribute('handle_id'));
		});
		if(shandle){
			$('#scheduletable tr[handle_id="'+shandle+'"]').click();
		}
	});
};
ws_sched.doCreateSchedule = function(check){
	if(typeof(check) == "undefined") check = true;
	var handle = $('#scheduletable tr.scheduleselected').attr('handle_id');
	if(handle){
		if(check == true){
			ws_sched.doCheckScheduleForChanges(ws_sched.doCreateSchedule);
			return;
		}
		$('#scheduletable tr[handle_id="'+handle+'"]').removeClass('scheduleselected');
		}
	ws_sched.initSchedule();
		$("#scheduleloading").hide();
		$("#schedule").show();
};

ws_sched.doDeleteSchedule = function(check){
	if(typeof(check) == "undefined") check = true;
	var handle = $('#scheduletable tr.scheduleselected').attr('handle_id');
	if(typeof(handle) == "undefined"){
		ws_util.messageDialog("Error","No schedule selected");
		return;
	}
	var name = $('#scheduletable tr.scheduleselected td:eq(0)').text();
	if(check){
		$('#dlg-delete-schedule').attr('title','Delete Schedule - '+name);
		$(function() {
			$("#dlg-delete-schedule").dialog({
				resizable: false,
				height:200,
				width:450,
				modal: true,
				buttons: {
					'Delete': function() {
						ws_sched.doDeleteSchedule(false);
						$(this).dialog('close');
					},
					'Cancel': function() {
						$(this).dialog('close');
					}
				}
			});
		});
	}else{
		$.get('/gui?q=remove&handle='+handle,function(data){
						ws_util.statusMessage('Schedule Deleted');
						ws_sched.loadScheduleList();
		});
	}
};

ws_sched.doCopySchedule = function(check){
	if(check == null) check = true;
	var handle = $('#scheduletable tr.scheduleselected:first').attr('handle_id');
	if(handle){
		if(check){
			ws_sched.doCheckScheduleForChanges(ws_sched.doCopySchedule);
			return;
		}
		$('#scheduletable tr[handle_id="'+handle+'"]').removeClass('scheduleselected');
	}else{
		ws_util.messageDialog("Error","No schedule selected");
		return;
 }
	ws_sched.loadSchedule(handle,true);
};


ws_sched.doSaveSchedule = function(isNew){
	if(isNew === "undefined"){
		isNew = true;
	}
	if($('#scheduleName').val() == ""){
		ws_util.messageDialog("Save Schedule","ERROR: Schedule must have name");
		return false;
	}
	if($('#schedGroup select :selected').length == 0){
		ws_util.messageDialog("Save Schedule","ERROR: No groups selected");
		return false;
	}
	ws_util.statusMessage("Saving Schedule...",5000);
	var handle = $('#scheduletable tr.scheduleselected').attr('handle_id');
	var isNew = false;
	var xmlData = ws_sched.getScheduleXML();
	if(typeof(handle) == "undefined"){
		isNew = true;
	}
	if(isNew){
		ws_util.post(xmlData,"Saved","Save Failure",function(result){
			if(result){
				ws_sched.loadScheduleList(isNew);
				$('#schedule').hide(isNew);
			}
		});
	}else{
		ws_util.post(xmlData,"Saved","Save Failure");
	}

	return true;
};

ws_sched.doCheckScheduleForChanges = function(callback){
	if (typeof(callback) != "function") callback = false;
	var handle = $('#scheduletable tr.scheduleselected').attr('handle_id');
	if(handle){
		// TODO check to see if values have actually been changed

		$(function() {
			$("#dlg-save-schedule").dialog({
				resizable: false,
				height:200,
				modal: true,
				buttons: {
					'Yes': function() {
						if(ws_sched.doSaveSchedule(false)){
							if(callback) callback(false);
						}
						$(this).dialog('close');
					},
					'No': function() {
						if(callback) callback(false);
						$(this).dialog('close');
					},
					Cancel: function() {
						$(this).dialog('close');
					}
				}
			});
		});
	}else{
		callback(false);
	}
};


ws_sched.selectSchedule = function(handle_id){
	var oldhandle = $('#scheduletable tr.scheduleselected:first').attr('handle_id');
	if(oldhandle){
		if(oldhandle != ''){
			if(oldhandle == handle_id){
				// alert("don't do anything");
				return;	
			}
			// check for changes?
			// TODO Ask for save/discard/cancel
			$('#scheduletable tr[handle_id="'+oldhandle+'"]').removeClass('scheduleselected');
		}
	}
	$('#scheduletable tr[handle_id="'+handle_id+'"]').addClass('scheduleselected');
	ws_sched.loadSchedule(handle_id);
};

ws_sched.setType = function(){
	if($("#fld5 input:radio:checked").val() == "Weekly"){
		$("#fld5 div:eq(0)").hide();
		$("#fld5 div:eq(1)").show();
		$("#overrideSchedule").parent().show();
	}else{
		$("#fld5 div:eq(1)").hide();
		$("#fld5 div:eq(0)").show();
		$("#overrideSchedule").parent().hide();
	}
};

ws_sched.initTimeRange = function(id){
	// start ==================================
	// type
	if(id=="tr1"){
		$("#"+id+" >span").html("Time Range:");
	}else{
		$("#"+id+" >span").html("Time Range 2:");
	}
	$("#"+id+" > div:eq(0) > select option[value='Fixed']").attr('selected','selected');
	// set hour to 12:00 am
	$("#"+id+" > div:eq(0) > div:eq(0) > select:eq(0) option[value='12']").attr('selected','selected');
	$("#"+id+" > div:eq(0) > div:eq(0) > select:eq(1) option[value='0']").attr('selected','selected');
	$("#"+id+" > div:eq(0) > div:eq(0) > select:eq(2) option[value='am']").attr('selected','selected');
	// set offset to 0:00
	$("#"+id+" > div:eq(0) > div:eq(1) > select:eq(0) option[value='0']").attr('selected','selected');
	$("#"+id+" > div:eq(0) > div:eq(1) > select:eq(1) option[value='0']").attr('selected','selected');
	$("#"+id+" > div:eq(0) > div:eq(1)").hide();
	ws_sched.setTRType(id,0);
	// end ================================
	$("#"+id+" > div:eq(1) > select option[value='Fixed']").attr('selected','selected');
	// set hour to 12:00 am
	$("#"+id+" > div:eq(1) > div:eq(0) > select:eq(0) option[value='12']").attr('selected','selected');
	$("#"+id+" > div:eq(1) > div:eq(0) > select:eq(1) option[value='0']").attr('selected','selected');
	$("#"+id+" > div:eq(1) > div:eq(0) > select:eq(2) option[value='am']").attr('selected','selected');
	// set offset to 0:00
	$("#"+id+" > div:eq(1) > div:eq(1) > select:eq(0) option[value='0']").attr('selected','selected');
	$("#"+id+" > div:eq(1) > div:eq(1) > select:eq(1) option[value='0']").attr('selected','selected');
	$("#"+id+" > div:eq(1) > div:eq(1)").hide();
	ws_sched.setTRType(id,1);
};

ws_sched.initSchedule = function(){
	$("#scheduleName").val("");
	$("#scheduleDescr").val("");
	var currentTime = new Date();
	var month = currentTime.getMonth() + 1;
	var day = currentTime.getDate();
	var year = currentTime.getFullYear();
	// $("#fld2 select:eq(0) option[value='Normal/After
	// Hours']").attr('selected','selected');
	$("#fld3 input:eq(0)").attr('checked',false);
	$("#fld3 input:eq(1)").val(""+month+"/"+day+"/"+year);
	$("#fld4 input:eq(0)").attr('checked',false);
	$("#fld4 input:eq(1)").val(""+month+"/"+day+"/"+(year+10));
	$("#fld3 input:eq(0)").keypress(function(event) {event.preventDefault();});
	$("#fld4 input:eq(0)").keypress(function(event) {event.preventDefault();});
	$("#fld5 input:eq(0)").attr('checked',true);
	$("#fld7").html('');
	ws_sched.setWeekly(true,true,true,true,true,false,false);
	ws_sched.setType();
	ws_sched.setActionType('Normal/After Hours', false);
	$("#fldLevel").hide();
	$("#fldLevel select").val(100);
	// set list of holiday schedules
	var os = $('#overrideSchedule');
	$(os).empty();
	var options='<option value="">--None Selected--</option>';
	$('#scheduletable tr').each(function(){
		type = $(this).find('td:eq(2)').text();
		if(type=="Holiday"){
			options+='<option value="'+$(this).attr('handle_id')+'">'+$(this).find('td:eq(0)').text()+"</option>";
	}
	});
	$(os).html(options);
	ws_sched.initTimeRange('tr1');
	ws_sched.initTimeRange('tr2');
};

ws_sched.loadSchedule = function (handle_id, clearName){
	if(typeof(clearName)== "undefined") clearName = false;
	$("#schedule").hide();
	ws_sched.initSchedule();
	$("#scheduleloading").show();
	$.get("/gui/schedules.xml?handle="+handle_id, function(xml){
		var name = $(xml).find('name:first').text();
		var start = $(xml).find('effectiveStart');
		var type = $(xml).find('type:first').text();
		var end = $(xml).find('effectiveEnd');
		var timeRange1 = $(xml).find('timeRange1');
		var timeRange2 = $(xml).find('timeRange2');
		ws_sched.setTimeRangeFromXML('tr1',timeRange1);
		ws_sched.setTimeRangeFromXML('tr2',timeRange2);
		$("#lfd7").html('');
		var days = $(xml).find('days');
		ws_sched.setDaysFromXML(days);
		if($("#fld5 input:radio:checked").val() == "Weekly"){
			var override = $(xml).find('overrideSchedule:first');
			if(override.length > 0){
				$('#overrideSchedule').val($(override).find('handle').text());
			}
		}
		if(clearName){
			$("#scheduleName").val("");
		}else{
			$("#scheduleName").val(name);
		}
		if($(xml).find('controlLevel').length > 0){
			$("#fldLevel select").val($(xml).find('controlLevel:first').text());
		}
		$("#scheduleDescr").val($(xml).find('description:first').text());
		$("#fld3 input:eq(1)").val($(start).find('month').text()+'/'+(start).find('day').text()+'/'+(start).find('year').text());
		$("#fld3 input:eq(1)").datepicker(($(start).find('active').text()=="true"?"enable":"disable"));
		$("#fld3 input:eq(0)").attr("checked",$(start).find('active').text()=="true");
		$("#fld4 input:eq(1)").val($(end).find('month').text()+'/'+(end).find('day').text()+'/'+(end).find('year').text());
		$("#fld4 input:eq(1)").datepicker(($(end).find('active').text()=="true"?"enable":"disable"));
		$("#fld4 input:eq(0)").attr("checked",$(end).find('active').text()=="true");
		var groups = $(xml).find('groups');
		ws_sched.setActionType(type, false);
		ws_sched.setGroupsFromXML(groups);
		$("#scheduleloading").hide();
		$("#schedule").show();
	});
};

ws_sched.getScheduleXML = function(){
	var type = $('#fld2 select:eq(0) :selected').val();
	var aclass = '';
	var os = '';
	if(type == "Normal/After Hours"){
		aclass="BWSAfterHoursSchedule";
	}else if(type == "Set Level"){
		aclass="BWSLevelSchedule";
	}
	var handle = $('#scheduletable tr.scheduleselected:first').attr('handle_id');
	var xml = _ws.xml;
	xml+= '<schedule t="com.wattstopper.schedule.'+aclass+'">\n';
	if(typeof(handle) != "undefined"){
		xml+='<handle>'+handle+'</handle>\n';
		}
	xml+= '<name><![CDATA['+$('#scheduleName').val()+']]></name>\n';
	xml+= '<description><![CDATA['+$('#scheduleDescr').val()+']]></description>\n';
	if(type == "Set Level"){
		xml+= '<controlLevel>'+$('#fldLevel select').val()+'</controlLevel>\n';
	}
	xml+= '<effectiveStart t="segman:WSDate">\n';
	xml+= '\t<active>'+($('#fld3 input:eq(0)').attr('checked')?'true':'false')+'</active>\n';
	xml += ws_sched.getDatleXML( $('#fld3 input:eq(1)').val(), '\t');
	xml+= '</effectiveStart>\n';
	xml+= '<effectiveEnd t="segman:WSDate">\n';
	xml+= '\t<active>'+($('#fld4 input:eq(0)').attr('checked')?'true':'false')+'</active>\n';
	xml += ws_sched.getDatleXML( $('#fld4 input:eq(1)').val(), '\t');
	xml+= '</effectiveEnd>\n';
	xml += ws_sched.getTimeRangeXML('timeRange1','#tr1');
	xml += ws_sched.getTimeRangeXML('timeRange2','#tr2');
	xml += '<days t="segman:WSDaySelector">\n';
	if( $('#fld5 input:radio:checked').val() == 'Weekly'){
		xml += '\t<dayType t="">Weekdays</dayType>\n';
		xml += '\t<Weekdays t="segman:WSWeekdays">\n';
		xml += '\t\t<Monday >'+($('#sw0').attr('checked')!=undefined)+'</Monday>\n';
		xml += '\t\t<Tuesday>'+($('#sw1').attr('checked')!=undefined)+'</Tuesday>\n';
		xml += '\t\t<Wednesday>'+($('#sw2').attr('checked')!=undefined)+'</Wednesday>\n';
		xml += '\t\t<Thursday>'+($('#sw3').attr('checked')!=undefined)+'</Thursday>\n';
		xml += '\t\t<Friday>'+($('#sw4').attr('checked')!=undefined)+'</Friday>\n';
		xml += '\t\t<Saturday>'+($('#sw5').attr('checked')!=undefined)+'</Saturday>\n';
		xml += '\t\t<Sunday>'+($('#sw6').attr('checked')!=undefined)+'</Sunday>\n';
		xml += '\t</Weekdays>\n';
		os = $('#overrideSchedule').val();
	}else{
		xml += '\t<dayType t="">Holiday</dayType>\n';
		$('#fld7 option').each(function(i, item){
			xml += '\t<day t="segman:WSDate">\n\t\t<active>true</active>\n'+ws_sched.getDatleXML($(item).text(),'\t\t')+'\t</day>\n';
		});
		}
	xml += '</days>\n';
	if( $('#fld5 input:radio:checked').val() == 'Weekly'){
		if(os != "") xml += '\t<overrideSchedule><handle>'+os+'</handle></overrideSchedule>\n';
	}
	xml += '<groups>\n';
	$('#schedGroup select :selected').each(function(i, item){
		xml += '\t<group><handle>'+$(item).val()+'</handle><name><![CDATA['+$(item).text()+']]></name></group>\n';
	});
	xml += '</groups>\n';
	xml+='</schedule>';
	ws_util.logMessage(xml.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;'));
	return xml;
};

ws_sched.getDatleXML = function(adate, indent){
 var xml = '';
 if(adate != ''){
  adate = adate.split('/',3);
  xml+= indent+'<year>'+adate[2]+'</year>\n';
  xml+= indent+'<month>'+adate[0]+'</month>\n';
  xml+= indent+'<day>'+adate[1]+'</day>\n';
	}
 return xml;
};

ws_sched.getTimeRangeXML = function(name, node) {
 var xml = '<'+name+'>\n';
 xml += '\t<start t="segman:WSScheduleTime">\n'+ws_sched.getTimeSetting(node+' > div:eq(0) ')+'\t</start>\n';
 xml += '\t<end t="segman:WSScheduleTime">\n'+ws_sched.getTimeSetting(node+' > div:eq(1) ')+'\t</end>\n';
 xml += '</'+name+'>\n';
 return xml;
};

ws_sched.getTimeSetting = function(node){
 var type = $(node + ' > select :selected').val();
 var xml = '';
 if(type == 'Fixed'){
  xml+= '\t\t<type>Fixed</type>\n';
  var hrs = Number($(node + ' > div:eq(0) > select:eq(0) :selected').val());
  var min = Number($(node + ' > div:eq(0) > select:eq(1) :selected').val());
  var ampm = $(node + ' > div:eq(0) > select:eq(2) :selected').val();
  if(hrs == '12' && ampm == 'am' ){
   hrs = 0;
  }else{
   if(ampm == 'pm' && hrs != 12){
    hrs += 12;
   }
   if(hrs == 24) {
    hrs = 0;
   }
  }
  xml+= '\t\t<hour>'+hrs+'</hour>\n';
  xml+= '\t\t<minute>'+min+'</minute>\n';
  xml+= '\t\t<second>0</second>\n';
 }else {
  xml += '\t\t<type>Astronomic</type>\n';
  if(type == 'Sunrise'){
   xml+= '\t\t<sunType>sunrise</sunType>\n';
  }else{
   xml+= '\t\t<sunType>sunset</sunType>\n';
  }
  var hrsSrc = $(node + ' > div:eq(1) > select:eq(0) :selected').val();
  var hrs = Math.abs(Number(hrsSrc));
  var min = Number($(node + ' > div:eq(1) > select:eq(1) :selected').val());
  var offset = (hrs * 60);
  var sign = (hrsSrc.substring(0,1)=='-')? -1: 1;
  if(Math.abs(offset) < 120 ){
   if(offset < 0) {
    offset -= min;
	}else{
    offset += min;
   }
  }
  offset*=sign;
  xml+= '\t\t<offset>'+offset+'</offset>\n';
	}
 return xml;
};

ws_sched.loadGroups = function()
{
	$.get("/gui/groups.xml", function (data){
		_ws.groupData = data;
	});
};

ws_sched.groupInActionType = function(groupType, actionType)
{
	if(ws_sched.actionGroupTypes[actionType]){
		var types = ws_sched.actionGroupTypes[actionType];
		for(var i=0; i<types.length; i++){
			if(types[i] == groupType){
				return true;
							}
						}
					}
	return false;
};

ws_sched.setGroupList = function(type, preserve)
{
	if(typeof(preserve)== "unidentified") preserve = true;
	var current = $('#schedGroup select').val();
	if(_ws.groupData != null){
		var options = '';// '<option value="">&lt;&lt; Not Selected &gt;&gt;</option>';
		$(_ws.groupData).find('group').each(function(){
			var actionType = $(this).find('actionType').text();
			if( ws_sched.groupInActionType(actionType, type) ){ // actionType == type){
				var handle = $(this).find('handle').text();
				var name = $(this).find('name').text();
				var description = $(this).find('description').text();
				var actionType = $(this).find('actionType').text();
				if(actionType == "networkID")description += " - Network Button ID";
				else description += " - Group of "+actionType;
				options+='<option value="'+handle+'" title="'+description+'-'+actionType+'">'+name+'</option>';
						}
		});
		$('#schedGroup select').html(options);
		if(current != '' && preserve){
			$('#schedGroup select').val(current);
					}
				}
};

ws_sched.setGroupsFromXML = function(groups)
{
	$(groups).find('group').each( function(){
		var handle = $(this).find('handle').text();
		$("#schedGroup select option[value='"+handle+"']").attr('selected','selected');
	});
};

ws_sched.doAddDate = function(dateText){
	var exists = $('#fld7 option[value="'+dateText+'"]');
	if(exists.length > 0) return;
	$('#fld7').append('<option value="'+dateText+'">'+dateText+'</option>');
};

ws_sched.doDeleteDate = function(){
	$('#fld7 :selected').remove();
};

ws_sched.updateActionType = function(){
	var type = ws_sched.getActionType();
	if(type == "Set Level"){
		$("#fldLevel").show();
	}
	ws_sched.setGroupList(type,true);
};

ws_sched.setActionType = function(type, preserve){
	if(typeof(preserve) == 'unidentified')preserve = true;
	$("#fld2 select:eq(0) option[value='"+type+"']").attr('selected','selected');
	if(type == "Set Level"){
		$("#fldLevel").show();
	}
	ws_sched.setGroupList(type, preserve);
};

ws_sched.getActionType = function(){
	var type = $("#fld2 select:eq(0) :selected").val();
	return type;
};

ws_sched.setWeekly = function(mon,tue,wed,thu,fri,sat,sun){
	$("#sw0").attr('checked',mon);
	$("#sw1").attr('checked',tue);
	$("#sw2").attr('checked',wed);
	$("#sw3").attr('checked',thu);
	$("#sw4").attr('checked',fri);
	$("#sw5").attr('checked',sat);
	$("#sw6").attr('checked',sun);
};

ws_sched.setWeeklyFromXML = function(weekdays){
	var mon = $(weekdays).find('Monday'   ).text() == "true";
	var tue = $(weekdays).find('Tuesday'  ).text() == "true";
	var wed = $(weekdays).find('Wednesday').text() == "true";
	var thu = $(weekdays).find('Thursday' ).text() == "true";
	var fri = $(weekdays).find('Friday'   ).text() == "true";
	var sat = $(weekdays).find('Saturday' ).text() == "true";
	var sun = $(weekdays).find('Sunday'   ).text() == "true";
	ws_sched.setWeekly(mon,tue,wed,thu,fri,sat,sun);
};

ws_sched.setHolidaysFromXML = function(days){
	$('#fld7').html("");
	$(days).children().each( function(){
		if($(this).attr('t') == "segman:WSDate"){
			var date = $(this).find('month').text()+'/'+$(this).find('day').text()+'/'+$(this).find('year').text();
			ws_sched.doAddDate(date);
		}
	});
};

ws_sched.setDaysFromXML = function(days){
	var type = $(days).find('dayType').text();
	if(type == "Weekly"){
		$("#fld5 input:eq(0)").attr('checked',true);
		ws_sched.setWeeklyFromXML($(days).find('Weekdays'));
	}else{
		$("#fld5 input:eq(1)").attr('checked',true);
		ws_sched.setHolidaysFromXML(days);
	}
	ws_sched.setType();
};

ws_sched.setTimeRangeAstro = function(id,ss,type,offset){
	$("#"+id+" > div:eq("+ss+") > select option[value='"+type+"']").attr('selected','selected');
	var sign='';
	if(Number(offset) < 0) sign='-';
	//alert(offset + " option[value='"+sign+""+(Math.floor(Math.abs(offset)/60))+"'] " + sign);
	$("#"+id+" > div:eq("+ss+") > div:eq(1) > select:eq(0) option[value='"+sign+""+(Math.floor(Math.abs(offset)/60))+"']").attr('selected','selected');
	$("#"+id+" > div:eq("+ss+") > div:eq(1) > select:eq(1) option[value='"+(Math.abs(offset)%60)+"']").attr('selected','selected');
	$("#"+id+" > div:eq("+ss+") > div:eq(0)").hide();
	$("#"+id+" > div:eq("+ss+") > div:eq(1)").show();
};

ws_sched.setTimeRangeFixed = function(id,ss,hours,minutes){
	var houradj = hours > 0 ? (hours > 12? hours-12: hours):12;
	$("#"+id+" > div:eq("+ss+") > select option[value='Fixed']").attr('selected','selected');
	$("#"+id+" > div:eq("+ss+") > div:eq(0) > select:eq(0) option[value='"+houradj+"']").attr('selected','selected');
	$("#"+id+" > div:eq("+ss+") > div:eq(0) > select:eq(1) option[value='"+minutes+"']").attr('selected','selected');
	$("#"+id+" > div:eq("+ss+") > div:eq(0) > select:eq(2) option[value='"+(hours < 12?"am":"pm")+"']").attr('selected','selected');
	$("#"+id+" > div:eq("+ss+") > div:eq(1)").hide();
	$("#"+id+" > div:eq("+ss+") > div:eq(0)").show();
};

ws_sched.setTimeRangeFromXML = function(id,timerange){
	var start = $(timerange).find('start');
	if(id=="tr1"){
		$("#"+id+" > span").html("Time Range: "+$(timerange).find('descr').text());
	}else{
		$("#"+id+" > span").html("Time Range 2: "+$(timerange).find('descr').text());
	}
	if($(start).find('type').text() == "Fixed"){
		ws_sched.setTimeRangeFixed(id,0,$(start).find('hour').text(),$(start).find('minute').text());
	}else{
		if( $(start).find('sunType').text() == 'sunrise'){
			ws_sched.setTimeRangeAstro(id,0,'Sunrise',$(start).find('offset').text());
		}else{
			ws_sched.setTimeRangeAstro(id,0,'Sunset',$(start).find('offset').text());
		}
	}
	var end = $(timerange).find('end');
	if($(end).find('type').text() == "Fixed"){
		ws_sched.setTimeRangeFixed(id,1,$(end).find('hour').text(),$(end).find('minute').text());
	}else{
		if( $(end).find('sunType').text() == 'sunrise'){
			ws_sched.setTimeRangeAstro(id,1,'Sunrise',$(end).find('offset').text());
		}else{
			ws_sched.setTimeRangeAstro(id,1,'Sunset',$(end).find('offset').text());
		}
	}
};

ws_sched.setTRType = function(id, ss){
	if($("#"+id+" > div:eq("+ss+") > select").val() =="Fixed"){
		$("#"+id+" > div:eq("+ss+") > div:eq(1) ").hide();
		$("#"+id+" > div:eq("+ss+") > div:eq(0) ").show();
	}else{
		$("#"+id+" > div:eq("+ss+") > div:eq(0) ").hide();
		$("#"+id+" > div:eq("+ss+") > div:eq(1) ").show();
	}
};

ws_sched.checkDate = function(num){
	if($("#fld"+num+" input:eq(0)").attr('checked')){
		$("#fld"+num+" input:eq(1)").datepicker("enable");
	}else{
		$("#fld"+num+" input:eq(1)").datepicker("disable");
		$("#fld"+num+" input:eq(1)").removeClass("dpenable");
	}
};

// ========================== DEVICES =======================================

var ws_device = {}; // device namespace

ws_device.needLoading = true;

ws_device.loadDevices = function(){
	ws_device.needLoading=false;
	$('#devicetree').jstree('destroy');
	$('#devicetree').empty();
	$('#device').html("");
	ws_util.statusMessage("Loading Device Tree...",10000);
	// $("#devicetree").jstree("set_theme","apple");
	$(function () {
		try{
			$.jstree._themes = "/ord?file:^gui/themes/";
			$("#devicetree").jstree({
				core : {
					"animation" : 0
					},
				"json_data" : {
					"progressive_render": true,
					"data" : [
					    {"attr":{"id":"dev_loc","rel":"folder","title":"devices by location"},"data":"Devices By Location","state":"closed"},
					    {"attr":{"id":"dev_net","rel":"folder","title":"devices by network"},"data":"Devices By Network","state":"closed"},
						{"attr":{"id":"dev_list","rel":"folder","title":"devices by name"},"data":"Devices By Name","state":"closed"},
						{"attr":{"id":"dev_grps","rel":"folder","title":"groups"},"data":"Groups","state":"closed"},
						{"attr":{"id":"dev_netIDs","rel":"folder","title":"network IDs"},"data":"Network IDs","state":"closed"}],
					"ajax" : {
						"async": true,
						"url" : function (n){
							var id = n.attr("id");
							if(id == "dev_list"){
								return "/gui/devices.json";
							}else if(id == "dev_loc"){
								return "/gui/location.json";
							}else if(id == "dev_net"){
								return "/gui/network.json";
							}else if(id == "dev_grps"){
								return "/gui/groups.json";
							}else if(id == "dev_netIDs"){
								return "/gui/networkIDs.json";
							}else if (id) {
								return "/gui/device.json?id=" + id; //add is
							}
							return -1;

						}
					}
//					,"xsl" : "nest"
				},
				"themes" : {
					"theme" : "wattstopper",
					"dots" : true,
					"icons" : true
				},
				"ui" : {
					"select_limit" : 1,
					"select_multiple_modifier" : "alt",
					"selected_parent_close" : "select_parent"
				},
				"types" : {
					"max_depth" : -2,
					"max_children" : -2,
					"valid_children" : "all",
					"type_attr" : 'ntype',
					"types" : ws_icon.type
				},
				"contextmenu" : {
					"items" : ws_device.rightClickMenu 					
				},
				"plugins" : [ "types", "themes", "ui", "json_data" , "sort", "contextmenu" ],
				"sort" : function (a,b) {
					try {
						
						//ws_util.logMessage("NodeType="+$(a.parentNode.parentNode).attr("rel")+" ntype="+$(a.parentNode.parentNode).attr("ntype"));
						if (jQuery(a.parentNode.parentNode).attr("rel") == "folder") {
							//then we are right under the folder, and we SHOULD sort
							var aStr = new String(this.get_text(a));
							var result = aStr.toLowerCase().localeCompare(this.get_text(b).toString().toLowerCase());
							//ws_util.logMessage("Sort a="+this.get_text(a)+" b="+this.get_text(b)+" Result="+result);
							return result;
						} else if (jQuery(a.parentNode.parentNode).attr("ntype") == "relays") {
							return (jQuery(a).attr('title') > jQuery(b).attr('title')) ? 1: -1;							
						}
					} catch (err) {
						ws_util.logMessage("ERRRO:"+err.message);
					}
					return 0; //getting here means we are at least below under the folder, so we shouldn't sort
				}
			}).bind("loaded.jstree", function() {
				ws_device.bindDevices();
				ws_util.statusMessage("Devices Loaded...");
			});
		}catch(err)
		{
		  txt="There was an error on this page.\n\n";
		  txt+="Error description: " + err.description + "\n\n";
		  txt+="Click OK to continue.\n\n";
		  alert(txt);
		}
	});
};

ws_device.sensors = ["BWSLMPC100", "BWSLMPX100", "BWSLMUC100", "BLMSENSOR", "BWSLMDX100", "BWSLMDC100" ];
ws_device.buttons = ["BLMBUTTON"];

ws_device.toggleBacnetExport = function(id, property, value) {	
	$.ajax({
		url: "/gui/toggleBacnetExport?id=" + id + "&property="+ property + (value == null ? "" : ("&value=" + value)),
		success: function(data) {
			//do something			
		}
	});
	
};

//ws_device.getJsonMenuString = function()

ws_device.generateRightClickForNode = function(textToCheck, handle, exportName) {
	
	
	randomLabel = Math.floor(Math.random()*100000);
	offText = "off" + randomLabel;
	readOnlyText = "readonly" + randomLabel;
	readWriteText = "readwrite" + randomLabel;
	writeAllText = "writeallpriorities" + randomLabel;
		
	var submenu = {};
	submenu[offText] = {
			"label": textToCheck == "disabled" ? "&#9745; Disabled" : "Disabled", 							
					"action": function(obj) { ws_device.toggleBacnetExport(handle,exportName,'disabled'); } 
				};
	submenu[readOnlyText] = {
			"label": textToCheck == "readonly" ? "&#9745; Read Only" : "Read Only", 
					"action": function(obj) { ws_device.toggleBacnetExport(handle,exportName,'readonly'); }
				}; 

	submenu[readWriteText] = { 
			"label": textToCheck == "writable" ? "&#9745; Read/Write" : "Read/Write",
			"action": function(obj) { ws_device.toggleBacnetExport(handle,exportName,'writable'); }
	};
	
	submenu[writeAllText] = { 
			"label": textToCheck == "writeall" ? "&#9745; Write All Priorities" : "Write All Priorities",
			"action": function(obj) { ws_device.toggleBacnetExport(handle,exportName,'writeall'); }
	};
	
	return submenu;
		
};

ws_device.rightClickMenu = function(node) {	
	var menu = {};
	//$("#devicetree").trigger('select_node.jstree', $("#devicetree"));
	var device_type = $(jq(node[0].id)).attr('ntype');
	if (!device_type) return menu;
	device_type = device_type.toUpperCase();
	
	var handle = node[0].id; //no multiple selections!	
	menu.title = { "label": $(jq(node[0].id)).attr('title'), "action" : null, "submenu": null, "_disabled": true, "separator_after" : true};
	
	if (device_type.indexOf("BLMLOAD") > -1) {
		menu.actions = { "label": "Actions", "action" : null, "submenu": {}};		
		menu.actions.submenu.on = { "label": "Turn On", "action": function(obj) { ws_config.updateValue(handle, "p_256", "100"); } };
		menu.actions.submenu.off = { "label": "Turn Off", "action": function(obj) { ws_config.updateValue(handle, "p_256", "0"); } };
		menu.actions.submenu.setload = { "label": "Dim to: ", "action": null, "submenu": {}};
		menu.actions.submenu.setload.submenu.twentyfive = { "label": "25", "action": function(obj) { ws_config.updateValue(handle, "p_256", "25"); } };
		menu.actions.submenu.setload.submenu.fifty = { "label": "50", "action": function(obj) { ws_config.updateValue(handle, "p_256", "50"); } };
		menu.actions.submenu.setload.submenu.seventyfive = { "label": "75", "action": function(obj) { ws_config.updateValue(handle, "p_256", "75"); } };
		
		if (_ws.exportConfiguration) {
			$.ajax({
				url: '/gui/bacnetExport.json?id=' + handle,
				success: function(data) {
					if (!data) return;
					menu.exportSection = { "label": "Bacnet Export", "action" : null, "submenu": {}};
					
					var text = ws_util.objectContains(data,'Load','.');
					
					if (text) {			
						menu.exportSection.submenu.load = { "label": "Load", "action": null, 
							"submenu": ws_device.generateRightClickForNode(text,handle,'Load')
						};
					}
					
					text = ws_util.objectContains(data,'LoadRelay','.');
					
					if (text) {						
						menu.exportSection.submenu.loadrelay = { "label": "Load Relay", "action": null, 
							"submenu": ws_device.generateRightClickForNode(text, handle, 'LoadRelay')
						};
					}
				},
				async: false
			});
		}
					
		
	} else if (device_type.indexOf("NETWORKBRIDGE") > -1) {
		menu.actions = { "label": "Actions", "action" : null, "submenu": {}};
		menu.actions.submenu.normalhours = { "label": "Normal Hours", "action": function(obj) { ws_config.updateValue(handle, "p_6", "false"); } };
		menu.actions.submenu.afterhours = { "label": "After Hours", "action": function(obj) { ws_config.updateValue(handle, "p_6", "true"); } };
		menu.actions.submenu.gotoscene = { "label": "Go to scene: ", "action": null, "submenu": {}};
		menu.actions.submenu.gotoscene.submenu.one = { "label": "1", "action": function(obj) { ws_config.updateValue(handle, "p_8", "1"); } };
		menu.actions.submenu.gotoscene.submenu.two = { "label": "2", "action": function(obj) { ws_config.updateValue(handle, "p_8", "2"); } };
		menu.actions.submenu.gotoscene.submenu.three = { "label": "3", "action": function(obj) { ws_config.updateValue(handle, "p_8", "3"); } };
		menu.actions.submenu.gotoscene.submenu.four = { "label": "4", "action": function(obj) { ws_config.updateValue(handle, "p_8", "4"); } };
		menu.actions.submenu.gotoscene.submenu.five = { "label": "5", "action": function(obj) { ws_config.updateValue(handle, "p_8", "5"); } };
		menu.actions.submenu.gotoscene.submenu.six = { "label": "6", "action": function(obj) { ws_config.updateValue(handle, "p_8", "6"); } };
		menu.actions.submenu.gotoscene.submenu.seven = { "label": "7", "action": function(obj) { ws_config.updateValue(handle, "p_8", "7"); } };
		menu.actions.submenu.gotoscene.submenu.eight = { "label": "8", "action": function(obj) { ws_config.updateValue(handle, "p_8", "8"); } };
		menu.actions.submenu.gotoscene.submenu.nine = { "label": "9", "action": function(obj) { ws_config.updateValue(handle, "p_8", "9"); } };
		menu.actions.submenu.gotoscene.submenu.ten = { "label": "10", "action": function(obj) { ws_config.updateValue(handle, "p_8", "10"); } };
		menu.actions.submenu.gotoscene.submenu.eleven = { "label": "11", "action": function(obj) { ws_config.updateValue(handle, "p_8", "11"); } };
		menu.actions.submenu.gotoscene.submenu.twelve = { "label": "12", "action": function(obj) { ws_config.updateValue(handle, "p_8", "12"); } };
		menu.actions.submenu.gotoscene.submenu.thirteen = { "label": "13", "action": function(obj) { ws_config.updateValue(handle, "p_8", "13"); } };
		menu.actions.submenu.gotoscene.submenu.fourteen = { "label": "14", "action": function(obj) { ws_config.updateValue(handle, "p_8", "14"); } };
		menu.actions.submenu.gotoscene.submenu.fifteen = { "label": "15", "action": function(obj) { ws_config.updateValue(handle, "p_8", "15"); } };
		menu.actions.submenu.gotoscene.submenu.sixteen = { "label": "16", "action": function(obj) { ws_config.updateValue(handle, "p_8", "16"); } };
		menu.actions.submenu.gotoscene.submenu.none = { "label": "None", "action": function(obj) { ws_config.updateValue(handle, "p_8", "17"); } };
		
		if (_ws.exportConfiguration) {
			$.ajax({
				url: '/gui/bacnetExport.json?id=' + handle,
				success: function(data) {
					if (!data) return;
					
					menu.exportSection = { "label": "Bacnet Export", "action" : null, "submenu": {}};
					
					
					if (data.LightingWatts) {
						menu.exportSection.submenu.lightingpower = { 
								"label": data.LightingWatts == "enabled" ? "&#9745; Lighting Power (Read Only)" : "Lighting Power (Read Only)", 
								"action": function(obj) { ws_device.toggleBacnetExport(handle,'LightingWatts'); } 
						};
					}
					
					if (data.PlugLoadWatts) {
						menu.exportSection.submenu.plugloadpower = { 
								"label": data.PlugLoadWatts == "enabled" ? "&#9745; Plug Load Power (Read Only)" : "Plug Load Power (Read Only)",
								"action": function(obj) { ws_device.toggleBacnetExport(handle,'PlugLoadWatts'); } 
						};
					}
					
					if (data.RoomOccupancy) {
						menu.exportSection.submenu.occupancy = {
								"label": data.RoomOccupancy == "enabled" ? "&#9745; Occupancy (Read Only)" : "Occupancy (Read Only)",
								"action": function(obj) { ws_device.toggleBacnetExport(handle,'Occupancy'); }
						};
					}
					
					if (data.AfterHours) {
						var afterHoursText = data.AfterHours.toLowerCase();
						menu.exportSection.submenu.normalafterhours = { "label": "Normal/After Hours", "action": null, 
							"submenu": ws_device.generateRightClickForNode(afterHoursText,handle,'AfterHours') //end submenu
						};
					}						
	
					if (data.SwitchLock) {
						var SwitchLockText = data.SwitchLock.toLowerCase();
						menu.exportSection.submenu.switchlock = { "label": "Switch Lock", "action": null, 
							"submenu": ws_device.generateRightClickForNode(SwitchLockText,handle,'SwitchLock')
						};
					}
				},
				async: false
			});
		}
		
	}else if ($.inArray(device_type, ws_device.sensors) > -1) {
		menu.timedelaynh = { "label": "Time Delay NH", "action" : null, "submenu": {}};
		menu.timedelaynh.submenu.x_one = { "label": "1", "action": function(obj) { ws_config.updateValue(handle, "p_258", "1"); } };
		menu.timedelaynh.submenu.x_two = { "label": "2", "action": function(obj) { ws_config.updateValue(handle, "p_258", "2"); } };
		menu.timedelaynh.submenu.x_three = { "label": "3", "action": function(obj) { ws_config.updateValue(handle, "p_258", "3"); } };
		menu.timedelaynh.submenu.x_four = { "label": "4", "action": function(obj) { ws_config.updateValue(handle, "p_258", "4"); } };
		menu.timedelaynh.submenu.x_five = { "label": "5", "action": function(obj) { ws_config.updateValue(handle, "p_258", "5"); } };
		menu.timedelaynh.submenu.x_six = { "label": "6", "action": function(obj) { ws_config.updateValue(handle, "p_258", "6"); } };
		menu.timedelaynh.submenu.x_seven = { "label": "7", "action": function(obj) { ws_config.updateValue(handle, "p_258", "7"); } };
		menu.timedelaynh.submenu.x_eight = { "label": "8", "action": function(obj) { ws_config.updateValue(handle, "p_258", "8"); } };
		menu.timedelaynh.submenu.x_nine = { "label": "9", "action": function(obj) { ws_config.updateValue(handle, "p_258", "9"); } };
		menu.timedelaynh.submenu.x_ten = { "label": "10", "action": function(obj) { ws_config.updateValue(handle, "p_258", "10"); } };
		menu.timedelaynh.submenu.x_eleven = { "label": "11", "action": function(obj) { ws_config.updateValue(handle, "p_258", "11"); } };
		menu.timedelaynh.submenu.x_twelve = { "label": "12", "action": function(obj) { ws_config.updateValue(handle, "p_258", "12"); } };
		menu.timedelaynh.submenu.x_thirteen = { "label": "13", "action": function(obj) { ws_config.updateValue(handle, "p_258", "13"); } };
		menu.timedelaynh.submenu.x_fourteen = { "label": "14", "action": function(obj) { ws_config.updateValue(handle, "p_258", "14"); } };
		menu.timedelaynh.submenu.x_fifteen = { "label": "15", "action": function(obj) { ws_config.updateValue(handle, "p_258", "15"); } };
		menu.timedelaynh.submenu.x_sixteen = { "label": "16", "action": function(obj) { ws_config.updateValue(handle, "p_258", "16"); } };
		menu.timedelaynh.submenu.x_seventeen= { "label": "17", "action": function(obj) { ws_config.updateValue(handle, "p_258", "17"); } };
		menu.timedelaynh.submenu.x_eighteen= { "label": "18", "action": function(obj) { ws_config.updateValue(handle, "p_258", "18"); } };
		menu.timedelaynh.submenu.x_nineteen= { "label": "19", "action": function(obj) { ws_config.updateValue(handle, "p_258", "19"); } };
		menu.timedelaynh.submenu.x_twenty= { "label": "20", "action": function(obj) { ws_config.updateValue(handle, "p_258", "20"); } };
		menu.timedelaynh.submenu.x_twentyone= { "label": "21", "action": function(obj) { ws_config.updateValue(handle, "p_258", "21"); } };
		menu.timedelaynh.submenu.x_twentytwo= { "label": "22", "action": function(obj) { ws_config.updateValue(handle, "p_258", "22"); } };
		menu.timedelaynh.submenu.x_twentythree= { "label": "23", "action": function(obj) { ws_config.updateValue(handle, "p_258", "23"); } };
		menu.timedelaynh.submenu.x_twentyfour= { "label": "24", "action": function(obj) { ws_config.updateValue(handle, "p_258", "24"); } };
		menu.timedelaynh.submenu.x_twentyfive= { "label": "25", "action": function(obj) { ws_config.updateValue(handle, "p_258", "25"); } };
		menu.timedelaynh.submenu.x_twentysix= { "label": "26", "action": function(obj) { ws_config.updateValue(handle, "p_258", "26"); } };
		menu.timedelaynh.submenu.x_twentyseven= { "label": "27", "action": function(obj) { ws_config.updateValue(handle, "p_258", "27"); } };
		menu.timedelaynh.submenu.x_twentyeight= { "label": "28", "action": function(obj) { ws_config.updateValue(handle, "p_258", "28"); } };
		menu.timedelaynh.submenu.x_twentynine= { "label": "29", "action": function(obj) { ws_config.updateValue(handle, "p_258", "29"); } };
		menu.timedelaynh.submenu.x_thirty= { "label": "30", "action": function(obj) { ws_config.updateValue(handle, "p_258", "30"); } };
		menu.timedelayah = { "label": "Time Delay NH", "action" : null, "submenu": {}};
		menu.timedelayah.submenu.one = { "label": "1", "action": function(obj) { ws_config.updateValue(handle, "p_259", "1"); } };
		menu.timedelayah.submenu.two = { "label": "2", "action": function(obj) { ws_config.updateValue(handle, "p_259", "2"); } };
		menu.timedelayah.submenu.three = { "label": "3", "action": function(obj) { ws_config.updateValue(handle, "p_259", "3"); } };
		menu.timedelayah.submenu.four = { "label": "4", "action": function(obj) { ws_config.updateValue(handle, "p_259", "4"); } };
		menu.timedelayah.submenu.five = { "label": "5", "action": function(obj) { ws_config.updateValue(handle, "p_259", "5"); } };
		menu.timedelayah.submenu.six = { "label": "6", "action": function(obj) { ws_config.updateValue(handle, "p_259", "6"); } };
		menu.timedelayah.submenu.seven = { "label": "7", "action": function(obj) { ws_config.updateValue(handle, "p_259", "7"); } };
		menu.timedelayah.submenu.eight = { "label": "8", "action": function(obj) { ws_config.updateValue(handle, "p_259", "8"); } };
		menu.timedelayah.submenu.nine = { "label": "9", "action": function(obj) { ws_config.updateValue(handle, "p_259", "9"); } };
		menu.timedelayah.submenu.ten = { "label": "10", "action": function(obj) { ws_config.updateValue(handle, "p_259", "10"); } };
		menu.timedelayah.submenu.eleven = { "label": "11", "action": function(obj) { ws_config.updateValue(handle, "p_259", "11"); } };
		menu.timedelayah.submenu.twelve = { "label": "12", "action": function(obj) { ws_config.updateValue(handle, "p_259", "12"); } };
		menu.timedelayah.submenu.thirteen = { "label": "13", "action": function(obj) { ws_config.updateValue(handle, "p_259", "13"); } };
		menu.timedelayah.submenu.fourteen = { "label": "14", "action": function(obj) { ws_config.updateValue(handle, "p_259", "14"); } };
		menu.timedelayah.submenu.fifteen = { "label": "15", "action": function(obj) { ws_config.updateValue(handle, "p_259", "15"); } };
		menu.timedelayah.submenu.sixteen = { "label": "16", "action": function(obj) { ws_config.updateValue(handle, "p_259", "16"); } };
		menu.timedelayah.submenu.seventeen= { "label": "17", "action": function(obj) { ws_config.updateValue(handle, "p_259", "17"); } };
		menu.timedelayah.submenu.eighteen= { "label": "18", "action": function(obj) { ws_config.updateValue(handle, "p_259", "18"); } };
		menu.timedelayah.submenu.nineteen= { "label": "19", "action": function(obj) { ws_config.updateValue(handle, "p_259", "19"); } };
		menu.timedelayah.submenu.twenty= { "label": "20", "action": function(obj) { ws_config.updateValue(handle, "p_259", "20"); } };
		menu.timedelayah.submenu.twentyone= { "label": "21", "action": function(obj) { ws_config.updateValue(handle, "p_259", "21"); } };
		menu.timedelayah.submenu.twentytwo= { "label": "22", "action": function(obj) { ws_config.updateValue(handle, "p_259", "22"); } };
		menu.timedelayah.submenu.twentythree= { "label": "23", "action": function(obj) { ws_config.updateValue(handle, "p_259", "23"); } };
		menu.timedelayah.submenu.twentyfour= { "label": "24", "action": function(obj) { ws_config.updateValue(handle, "p_259", "24"); } };
		menu.timedelayah.submenu.twentyfive= { "label": "25", "action": function(obj) { ws_config.updateValue(handle, "p_259", "25"); } };
		menu.timedelayah.submenu.twentysix= { "label": "26", "action": function(obj) { ws_config.updateValue(handle, "p_259", "26"); } };
		menu.timedelayah.submenu.twentyseven= { "label": "27", "action": function(obj) { ws_config.updateValue(handle, "p_259", "27"); } };
		menu.timedelayah.submenu.twentyeight= { "label": "28", "action": function(obj) { ws_config.updateValue(handle, "p_259", "28"); } };
		menu.timedelayah.submenu.twentynine= { "label": "29", "action": function(obj) { ws_config.updateValue(handle, "p_259", "29"); } };
		menu.timedelayah.submenu.thirty= { "label": "30", "action": function(obj) { ws_config.updateValue(handle, "p_259", "30"); } };
		
		if (_ws.exportConfiguration) {
			$.ajax({
				url: '/gui/bacnetExport.json?id=' + handle,
				success: function(data) {
					if (!data) return;
					
					if (data.DetectionState) {
						menu.exportSection = { "label": "Bacnet Export", "action" : null, 
							"submenu": {
								"detectionState" : {
									"label": data.DetectionState.toLowerCase() == "enabled" ? "&#9745; Detection State" : "Detection State", 
									"action": function(obj) { ws_device.toggleBacnetExport(handle,'DetectionState'); }
								}								
							}
						};
					}
				},
				async: false
			});
		}
		
	} else if (device_type.indexOf("BLMRELAY") > -1) {
		menu.actions = { "label": "Actions", "action" : null, "submenu": {}};		
		menu.actions.submenu.on = { "label": "Turn On", "action": function(obj) { ws_config.updateValue(handle, "p_256", "100"); } };
		menu.actions.submenu.off = { "label": "Turn Off", "action": function(obj) { ws_config.updateValue(handle, "p_256", "0"); } };
		if (_ws.exportConfiguration) {
			$.ajax({
				url: '/gui/bacnetExport.json?id=' + handle,
				success: function(data) {
					if (!data) return;
					
					var text = ws_util.objectContains(data,'Relay','.');
					if (text)
						menu.exportSection = { "label": "Bacnet Export", "action" : null, "submenu": ws_device.generateRightClickForNode(text,handle,'Relay') };									
				},
				async: false
			});
		}
	} else if (device_type.indexOf("BWSLMCHANNEL") > -1) {
		menu.actions = { "label": "Actions", "action" : null, "submenu": {}};
		menu.actions.submenu.normalhours = { "label": "Normal Hours", "action": function(obj) { ws_config.updateValue(handle, "p_6", "false"); } };
		menu.actions.submenu.afterhours = { "label": "After Hours", "action": function(obj) { ws_config.updateValue(handle, "p_6", "true"); } };
		if (_ws.exportConfiguration) {
			$.ajax({
				url: '/gui/bacnetExport.json?id=' + handle,
				success: function(data) {
					if (!data) return;
					
					var text = ws_util.objectContains(data,'Channel','.');												
					if (text) 
						menu.exportSection = { "label": "Bacnet Export", "action" : null, "submenu": ws_device.generateRightClickForNode(text,handle,'Channel') };									
				},
				async: false
			});
		}		

	} else if ($.inArray(device_type, ws_device.buttons) > -1) {
//TODO: Finish scene buttons when the gui actually works
//		menu.sceneactions = { "label": "Scene Button Actions", "action" : null, "submenu": {}};
//		menu.sceneactions.submenu.scene = { "label": "Scene", "action" : null, "submenu": {}};
//		menu.sceneactions.submenu.scene.one = { "label": "Scene", "action" : null, "submenu": {}};
		menu.loadactions = { "label": "Load Button Actions", "action" : null, "submenu": {}};
		menu.loadactions.submenu.on = { "label": "On", "action": function(obj) { ws_config.updateValue(handle, "p_256", "true"); } };
		menu.loadactions.submenu.off = { "label": "Off", "action": function(obj) { ws_config.updateValue(handle, "p_256", "false"); } };
	} else if (device_type.indexOf("BWSGROUP") > -1 ) { //should cover boolean and numeric groups 
		if (_ws.exportConfiguration) {
			$.ajax({
				url: '/gui/bacnetExport.json?id=' + handle,
				success: function(data) {
					if (!data) return;
					
					//format is Group.groupName
					var text = ""
					for (var prop in data) { //should only be one
						if (data.hasOwnProperty(prop)) {
							text = data[prop].toLowerCase();
						}
					}													
					menu.exportSection = { "label": "Bacnet Export", "action" : null, "submenu": ws_device.generateRightClickForNode(text,handle,'Group') };									
				},
				async: false
			});
		}
	}
	return menu;
};

ws_device.reloadDevices = function(style){
	// ws_device.loadDevices(style);
	$('#devicetree').bind("reopen.jstree", function() {
		ws_util.statusMessage("Devices Loaded...");
	}).jstree('refresh',-1);
};

ws_device.currentDeviceID = false;


ws_device.deviceSelected = function(data) {
			var handle = data.inst.get_selected().attr('id');
			var type = data.inst.get_selected().attr('ntype');
			if(_ws.debug)ws_util.logMessage("bindDevice:"+type+"-"+handle);
			ws_device.currentDeviceID=handle;
			_ws.resetMainTimer();
			$('#device').html('');
			$('#device').removeAttr('deviceID');
			ws_device.getDeviceData(handle, type);
};

ws_device.bindDevices = function(){
	$(function() {
		$("#devicetree").bind("select_node.jstree", function (e,data) {
			ws_device.deviceSelected(data);
		});
	});
};

ws_device.updateTreeDescription = function(name)
{
	var node = $.jstree._focused().get_selected();
	if($(node).length > 0){
	   $.jstree._focused().set_text(node, name);
	}
//	var node = $('#devicetree').jstree('get_selected');
//	if(node.length > 0){
//		$('#devicetree').jstree('rename_node',node, name);
//	}
};
ws_device.updateDevice = function()
{
	var currID = $('#device').attr('deviceID');
	if(typeof(currID) != "undefined"){
		if(_ws.debug) ws_util.logMessage("update device:"+currID);
		var handle = $('#devicetree').jstree('get_selected').attr('id');
		if(handle != ''){
			var type = $('#devicetree').jstree('get_selected').attr('ntype');
			if(_ws.debug)ws_util.logMessage("Handle:"+handle+" Type:"+type);
			ws_device.getDeviceData(handle, type);
		}else{
			ws_util.logMessage("Missing handle for currID:"+currID);
		}
	//}else{
		//ws_util.statusMessage("currID==Undefined");
	}
};

ws_device.gettingDevice="";
ws_device.getDeviceData = function(handle, type)
{
	if(ws_device.gettingDevice==handle){
		if(_ws.debug)ws_util.logMessage("skip");
		return;
	}
	//ws_util.statusMessage("Loading Device...");
	if(typeof(handle) == "undefined"){
		ws_util.logMessage("getDeviceData: handle undefined");
		return;
	}
	if(type == 'location'){
		$('#device').html("<div>Location: "+handle+"</div>");
	}else{
		var query = "/gui/devices.xml?handle="+handle;
		if(type == 'channels'){
			query = "/gui/status.xml?handle="+handle.substring(0,handle.length-1)+"&type=channels";
		}else if(type == 'relays'){
			query = "/gui/status.xml?handle="+handle.substring(0,handle.length-1)+"&type=relays";
		}else if(type == 'networkGroups'){
			query = "/gui/status.xml?handle="+handle.substring(0,handle.length-1)+"&type=networkGroups";
		}
		if(_ws.debug)ws_util.logMessage("getDeviceData:"+query);
		ws_util.get(query, function (data){
				if($(data).find('responseCode').text()){
					val = $(data).find('responseCode').text();
					if(val != "200" && val != "0"){
						ws_util.statusMessage('ERROR('+$(data).find('responseCode').text()+'):'+$(data).find('responseMessage').text());
					}
				}else{
					//if(_ws.debug)ws_util.logMessage("getDeviceData - Return from query");
					$(data).find('node:first').each(function(){
						ws_device.loadDeviceData(this);
					});
				}
			},
			function(){ws_device.gettingDevice="";_ws.systemOffline();},_ws.deviceTimeout);
	}
};

ws_device.toggleDeviceManagement = function(){
	if(_ws.deviceManagement){
		ws_util.statusMessage("Disabled Device Management",2000);
	}else{
		ws_util.statusMessage("Enabled Device Management",2000);
	}
	_ws.deviceManagement = !_ws.deviceManagement;
	$('#devicetree').jstree('destroy');
	$('#devicetree').empty();
	ws_device.needLoading=true;
};

ws_device.decodeSpecialValues = function(deviceType, name, value){
	//ws_util.logMessage(deviceType+" "+name+" "+value);
	if(deviceType == "LMBC_300" || deviceType.substr(0,5) == "LILM_" || deviceType.substr(0,5) == "LINB_"){
		if(name == "address"){
			bits = value.split(":");
			var mac = bits[1];
			if(bits[1].length == 2){
				mac = parseInt(mac,16);
			}
			value = "Network:"+bits[0]+" MAC:"+mac;
		}else if(name == "objectId"){
			bits = value.split(":");
			value = bits[1];
		}
	}
	return value;
};

ws_device.loadDeviceData = function(node){
	var handle = $(node).attr('handle');
	var enabled = $(node).attr('enabled');
	var deviceName = '';
	var deviceType = '';
	var update = false;
	var device = $('#device');
	if($(device).length == 0) {
		ws_util.logMessage("cannot find device div");
		return;
	}
	// This is a special workaround to allow the folders for channels and relays to use the panel's handle with a "C" or "R" appended to the handle.
	var currID = ws_device.currentDeviceID;
	if(currID != "" && currID.substring(0,2)== "h:") currID= currID.substring(0,7);
	if(handle != currID){
		//ws_util.logMessage("loadDeviceData: handles do not match: "+ws_device.currentDeviceID+" != "+handle);
		return;
	}
	var currID = $(device).attr('deviceID');
	$(device).attr('deviceID',handle);
	if(currID == handle) update = true;
	if(!update){
		//ws_util.logMessage("New Device");
		$(device).hide();
		var newtext = '<div enabled="'+enabled+'"><div class="devheader">';
		newtext+= '<img sr'; // JACE servlet will parce source attribute when serving up file, so split it up.
		newtext+= 'c="/'+$(node).attr('icon')+'" /><div><table>';
		newtext += '<tr><th>Device&nbsp;Name</th><td id="deviceNameCol"></td></tr>';
		newtext += '<tr><th>Device&nbsp;Type</th><td id="deviceTypeCol"></td></tr>';
		newtext+= '</table>';
		newtext+= '</div></div>\n<div id="sections">\n</div></div>';
		$(device).html(newtext);
	}else{
		//ws_util.logMessage("Update Device");
	}
	var objectID = 0;
	$(node).find('section').each(function(){
		// Load Sections ==========================================================
		var sectionName = $(this).attr('name');
		if($('#sec_'+sectionName.replace(/ /gi,'')).length == 0){
			//ws_util.statusMessage('Adding Section:'+sectionName);
			$('#sections').append('<div class="section" id="sec_'+sectionName.replace(/ /gi,'')+'"><div>'+sectionName+'</div>\n</div>\n');
		}
		var section = $('#sec_'+sectionName.replace(/ /gi,''));
		var visibleSettings = false;
		if(  $(this).attr('hidden') && $(this).attr('hidden') == 'true'){
			$(section).hide();
		}else{
			$(section).show();
		}
		$(this).find('setting').each(function(){
			// Load Settings ==========================================================
			var name = $(this).find('name:first').text();
			var ref = $(this).find('ref:first').text();
			var type = $(this).attr('type');
			var hiddenSlot = false;
			var hidden = false;
			var value = $(this).find('value:first').text();
			var description = $(this).find('description:first').text();
			if(  $(this).attr('alias')){
				description = $(this).attr('alias');
			}
			if(name == "description" && value != ""){
				ws_device.updateTreeDescription(value);
			}
			if(  $(this).attr('isHidden')){
				if($(this).attr('isHidden') == 'true'){
					hiddenSlot = true;
					ws_util.logMessage("Slot:"+name+" is not visible");
				}
			}
			var status = 'none';
			var replace = false;
			if($(this).find('status:first').text() != ""){
				status = $(this).find('status:first').text().replace('{','').replace('}','');
			}
			if( name == "deviceName" ) deviceName = value;
			if( name == "deviceType" ) deviceType = value;
			var isReadOnly = false;
			if(  $(this).attr('readonly') ){
				if($(this).attr('readonly') == 'true'){
					isReadOnly = true;
				}
			}
			if(enabled == "false" || status == "stale"){
				isReadOnly = true;
			}
			if($('#sid_'+name).length == 0){
				//ws_util.statusMessage("adding setting:"+name);
				replace = true;
				var facet = '';
				if($(this).find('facet:first').text() != ""){
					facet = '('+$(this).find('facet:first').text()+")";
				}
				$(section).append('<div class="setting" id="sid_'+name+'" isRO="'+(isReadOnly?'true':'false')+'"><span>'+description+facet+'</span><div class="value"></div></div>\n');
			}else{
				 replace = $('#sid_'+name).attr('isRO') != (isReadOnly?'true':'false');
				 $('#sid_'+name).attr('isRO',(isReadOnly?'true':'false'));
			}
			var setting = $('#sid_'+name);
			if($(setting).length != 1){
				ws_util.statusMessage("Cannot find setting:"+sectionName+"-"+name);
				return true;
			}
			if(  $(this).attr('hidden')){
				if($(this).attr('hidden') == 'true'){
					hidden = true;
				}
			}
			// display group id for network group id buttons
			if(name=='networkGroupID'){
				var mval = $('#sid_operationMode').attr('oldval');
				ws_util.logMessage("#sid_operationMode="+mval);
				if(mval == 29){
					hiddenSlot = false;
					hidden = false;
				}else{
					hidden = true;
				}
			}
			// handle momentaryMode for LMButton
			if(name=='momentaryMode'){
				hiddenSlot = false;
				var mval = $('#sid_operationMode').attr('oldval');
				if(mval == 29){
					$(setting).attr('values',$(setting).attr('ngvalues'));
				}else if (mval <16){
					$(setting).attr('values',$(setting).attr('svalues'));
				}
			}
			if(hidden || hiddenSlot){
				$(setting).hide();
			}else{
				visibleSettings = true;
			}
			$(setting).attr('status', status);
			value = ws_device.decodeSpecialValues(deviceType, name, value);
			if(name=='objectId')objectID=value;
			if(!replace && $(setting).attr('oldval') == value) {
				return true;
			}
			//ws_util.logMessage("replace="+replace+" "+$(setting).attr('oldval')+"=="+value);

			// ======================== SET VALUE ============================================
			$(setting).attr('oldval', value);
			var vdiv = $(setting).find("div.value");
			if(type == "boolean"){
				var trueText = $(this).attr('trueText');
				var falseText = $(this).attr('falseText');
				if(isReadOnly){
					$(vdiv).html( '<input type="text" name="'+ ref +'" readonly="readonly" value="'+(value == "true"?trueText:falseText)+'" />');
				}else{
					$(vdiv).html( '<input type="radio" id="'+handle+'-'+ref+'T" name="'+ref+'" onclick="ws_config.updateValue(\''+handle+'\',\''+ref+'\',\'true\');" '+(value == "true"?'checked="checked"':'')+' value="'+value+'"/><label for="'+handle+'-'+ref+'T">'+trueText+"</label>&nbsp; " +
					 '<input type="radio" id="'+handle+'-'+ref+'F" name="'+ref+'" onclick="ws_config.updateValue(\''+handle+'\',\''+ref+'\',\'false\');" '+(value=="false"?'checked="checked"':'')+' value="'+value+'"/><label for="'+handle+'-'+ref+'F">'+falseText+"</label>");
				}
			}else if(type=="int"){
				if(isReadOnly){
					var values = $(this).attr('values');
					if(typeof(values) == "undefined" || values == ""){
						$(vdiv).html( '<input type="text" name="'+ ref +'" readonly="readonly" value="'+value+'" />');
					}else{
						var displayEnum = ws_util.buildenum($(this).attr('values'));
						$(vdiv).html( '<input type="text" name="'+ ref +'" readonly="readonly" value="'+(displayEnum[value]?displayEnum[value]:value)+'" />');
					}
				}else{
					var values = $(this).attr('values');
					if(typeof(values) == "undefined" || values == ""){
						$(vdiv).html( '<input name="'+ ref +'" id="'+handle+'V" onchange="ws_config.updateValue(\''+handle+'\',\''+ref+'\',this)" value="'+value+'">');
					}else{
						$(vdiv).html( '<select name="'+ ref +'" id="'+handle+'V" onchange="ws_config.updateValue(\''+handle+'\',\''+ref+'\',this)" >'+ws_util.selectOptionsFromValues($(this).attr('values'),value)+"</select>");
					}
					// allow for creation of action buttons from the xml attributes of the property
					var count = 1;
					while(typeof($(this).attr('btn'+count)) != 'undefined'){
						var val = $(this).attr('btn'+count);
						var vals = val.split('=');
						if(vals.length == 2){
							$(vdiv).append( '<input type="submit" value="'+vals[1]+'" onclick="ws_config.updateValue(\''+handle+'\',\''+ref+'\',\''+vals[0]+'\');return false;" /> ');
						}else{
							$(vdiv).append( '<input type="submit" value="'+val+'" onclick="ws_config.updateValue(\''+handle+'\',\''+ref+'\',\''+val+'\');return false;" /> ');
						}
						count++;
					}
				}
			}else if(type=="double"){
				if(isReadOnly){
					if(  $(this).attr('precision') ){
						var precision = $(this).attr('precision');
						var num = new Number(value);
						$(vdiv).html( '<input type="text" name="'+ ref +'" readonly="readonly" value="'+num.toFixed(precision)+'" />');
					}else{
						$(vdiv).html( '<input type="text" name="'+ ref +'" readonly="readonly" value="'+value+'" />');
					}
				}else{
					if(  $(this).attr('precision') ){
						var precision = $(this).attr('precision');
						var num = new Number(value);
						$(vdiv).html( '<input type="text" name="'+ ref +'" '+'onchange="ws_config.updateValue(\''+handle+'\',\''+ref+'\',this)" value="'+num.toFixed(precision)+'" />');
					}else{
						$(vdiv).html( '<input type="text" name="'+ ref +'" '+'onchange="ws_config.updateValue(\''+handle+'\',\''+ref+'\',this)" value="'+value+'" />');
					}
				}
			}else{
				if(isReadOnly){
					$(vdiv).html( '<input type="text" name="'+ ref +'" readonly="readonly" value="'+value+'" />');
				}else{
					$(setting).attr('oldval', ''); //this is to purposely change the old value to something we aren't, forcing a refresh of these values
					$(vdiv).html( '<input handle="' + handle + '" id="' + handle + "-" + ref + '" type="text" name="'+ ref +'" value="'+value+'" /><span id="' + handle+ '-' + ref +'error" style="float:right;color:red;"></span>');
					var ourInput = $(jq(handle + "-" + ref));
					// onkeyup="ws_config.checkTextValue(\''+handle+'\',this)" 
					ourInput.keyup(function() {
						ws_config.checkTextValue(handle,this);
					});
					ourInput.focusin(function() {
						_ws.pauseMainTimer();
						$('#focuswarning').text('Warning! Page will not refresh while focused on a text box. Click out of the text box to re-enable auto refresh.');
					});
					ourInput.focusout(function() {						
						var errorMsg = $(jq(this.ref+'error')).text();						
						if (!errorMsg) {
							ws_config.updateValue($(jq(this.id)).attr('handle'),this.name,this);
						} else {						
							_ws.resetMainTimer();	
						}
						$('#focuswarning').empty();
					});					
				}
			}

		});
		if(!visibleSettings)$(section).hide();
	});
	// add configuration information to LMIO301
	if(deviceType == "LMIO_301"){
		if($('#sec_fcevents').length == 0){
			x="<table id=\"lmioactions\"><tr><th>#</th><th>Action</th><th>Cond</th><th>Setpoint</th><th>Delay</th><th>Target Group(s)</th></tr>\n";
			x+="</table>\n";
			if(_ws.admin) x+="<div><input type=\"Submit\" value=\"Add\" onclick=\"ws_device.selectAction(false);ws_device.editAction(true);\"/><input type=\"Submit\" value=\"Edit\" onclick=\"ws_device.editAction(false);return false;\"/><input type=\"Submit\" value=\"Delete\"/ onclick=\"ws_device.deleteFCEvent(true);return false;\"></div>\n";
			//ws_util.statusMessage('Adding Section:'+sectionName);
			$('#sections').append('<div class="section" id="sec_fcevents" needsRefresh="1"><div>Events</div>\n'+x+'</div>\n');
		}
		var section = $('#sec_fcevents');
		if($(section).attr('needsRefresh')=="1"){
			$('tr.actionlisting').remove();
			$(section).attr('needsRefresh',"0");
			ws_device.addFCEvent(node);
			$('#lmioactions tr').click(function() {
				ws_device.selectAction(this.getAttribute('handle_id'));
			});
		}
	}
	if(update){// during update
	}else{ // on first load
		if(deviceType == "NetworkGroup"){
			$('#sections').append('<div class="section" id="sec_groups"><div>Group Control</div>\n</div>\n');
			var section = $('#sec_groups');
			x = '<div class="setting" id="sid_groups" isRO="false"><span>ControlGroups</span><div class="value">';
			x = '<select id="selnetgrps" multiple="multiple" readonly="readonly">';  //onchange="$(\'#sec_group_save\').something>';
			$(node).find('links:first').each(function(){
				$(this).find('link').each(function(){
					//alert($(this).find("name"));
					x+= '<option value="'+$(this).find("handle:first").text()+'">'+$(this).find("name:first").text()+'</option>';
				});
			});
			x+= '</select>';
			x+= '</div></div>\n';
			if(_ws.admin) x+="<div><input type=\"Submit\" value=\"Edit Groups\" onclick=\"ws_device.editGroups();return false;\"/></div>\n";
			$(section).html($(section).html()+x);
		}
		if( _ws.admin && deviceType == "BUTTON"){
			if($('#sid_operationMode').length > 0){
				if($('#sid_operationMode').attr('oldval') != "Rocker"){
					$('#sid_operationMode').append("<input type=\"button\" value=\"Change Mode\" onclick=\"ws_device.changeButtonMode();\"/>");
				}
			}
		}

		$('#deviceNameCol').html(deviceName);
		$('#deviceTypeCol').html(deviceType);
		$('#device').show();
	}
	//On first load, Things to add to page if device management is activated
	if(_ws.admin && _ws.deviceManagement && !update){ // tech features on devices
		if(deviceType == "LMBC_300"){
			$('#sections').append('<div class="section" id="sec_deviceMgmnt"><div>Device Management</div>\n</div>\n');
			var section = $('#sec_deviceMgmnt');
			x = '<div class="setting" id="" isRO="false"><span title="Reboot the network bridge module, will re-inventory the room devices. Re-Discover is recommended after a Reset.">Reset Device</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Reset This Device\" onclick=\"ws_device.resetRoom('"+handle+"');\"/>";
			x+="</div></div>\n";
			var version = $('#sid_firmwareRevision').attr('oldval');
			if(typeof(version)!= 'undefined' && version > 5.12){
				x+= '<div class="setting" id="" isRO="false"><span title="Query firmware version of the lmbc and all devices in the room">Request Device Versions</span><div class="value">';
				x+="<input type=\"Submit\" value=\"RequestDeviceVersions\" onclick=\"ws_device.requestRoomVersions('"+handle+"');\"/>";
				x+="</div></div>\n";
			}
			x+= '<div class="setting" id="" isRO="false"><span title="Deletes this network bridge and all associated devices from the database">Remove Device</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Remove This Device\" onclick=\"ws_device.deleteDevice('"+handle+"');\"/>";
			x+="</div></div>\n";
			x+= '<div class="setting" id="" isRO="false"><span title="Upgrade Firmware of this device. NOTE: Will disable all devices during firmware upgrade process to optimize network traffic. Devices will re-enable after upgrade complete.">Upgrade Firmware</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Request Firmware Upgrade\" onclick=\"ws_device.booloatDevice('"+handle+"');\"/>";
			x+="</div></div>\n";
			x+= '<div class="setting" id="" isRO="false"><span title="Run a discovery process for this Device ID only, reload all information for this network bridge and room deivces in the database">Re-Discover Device</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Re-Discover This Device\" onclick=\"ws_config.customDiscovery("+objectID+","+objectID+");\"/>";
			x+="</div></div>\n";
			$(section).html($(section).html()+x);
		}
		if(deviceName == "LILM"){
			$('#sections').append('<div class="section" id="sec_deviceMgmnt"><div>Device Management</div>\n</div>\n');
			var section = $('#sec_deviceMgmnt');
			x = '<div class="setting" id="" isRO="false"><span>Remove Device</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Remove This Device\" onclick=\"ws_device.deleteDevice('"+handle+"');\"/>";
			x+="</div></div>\n";
			x+= '<div class="setting" id="" isRO="false"><span>Re-Discover Device</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Re-Discover This Device\" onclick=\"ws_config.customDiscovery("+objectID+","+objectID+");\"/>";
			x+="</div></div>\n";
			$(section).html($(section).html()+x);
		}
		if(deviceType == "BUTTON"){
			$('#sections').append('<div class="section" id="sec_deviceMgmnt"><div>Device Management</div>\n</div>\n');
			var section = $('#sec_deviceMgmnt');
			x = '<div class="setting" id="" isRO="false"><span>Update Button Mode</span><div class="value">';
			x+="<input type=\"Submit\" value=\"Re-Read Button Properties\" onclick=\"ws_device.reReadButtonMode('"+handle+"');\"/>";
			x+="</div></div>\n";
			$(section).html($(section).html()+x);
		}
	}
};

ws_device.reReadButtonMode = function(handle){
	ws_util.get('/gui?q=reReadButtonMode&handle='+handle, function(data) {
		$('.result').html(data);
	});
};

ws_device.changeButtonMode = function()
{
	var mode = $('#sid_operationMode').attr('oldval');
	var id =  $('#sid_networkGroupID div.value input').val();
	//alert(mode + " " + id);
	$('#loadbtnmode').val(0);
	$('#networkbtnmode').val(3);
	$('#scenebtnmode').val(1);
	$('#sceneSelector').val(1);
	if(mode > 253){
		mode = "Load";
		$('#loadbtnmode').val($('#sid_momentaryMode').attr('oldval'));
	}else if(mode == 29){
		mode = "Network Group";
		$('#networkbtnmode').val($('#sid_momentaryMode').attr('oldval'));
	}else if(mode < 16){
		mode = "Scene";
		$('#scenebtnmode').val($('#sid_momentaryMode').attr('oldval'));
	}
	$('#btn-mode-form input:radio[value="'+mode+'"]').attr('checked','checked');
	$('#btn-mode-form input[name="number"]').val(id);
 	$(function() {
		$('#btn-mode-form').dialog({
			height: 440,
			width: 450,
			modal: true,
			buttons: {
				"Save": function() {
					if($('#btn-mode-form input:checked').length>0){
						//alert('/gui?q=buttonMode&handle='+$('#device').attr('deviceid')+'&mode='+mode+'&num='+id);
						var a = $('#btn-mode-form input:checked').val();
						var b = 0;
						var c = 0;
						if(a == "Load"){
							c = $('#loadbtnmode').val();
						}else if(a == "Scene"){
							b = $('#sceneSelector').val();
							c = $('#scenebtnmode').val();
						}else if(a = "Network Group"){
							b = $('#btn-mode-form input[name="number"]').val();
							c = $('#networkbtnmode').val();
						}
						$.get('/gui?q=buttonMode&handle='+$('#device').attr('deviceid')+'&mode='+a+'&num='+b+'&momentarymode='+c, null, function(data,status) {
							if(status == "success"){
								//refresh tree nodes for networkIDs when a switch changes mode.
								$('#devicetree').jstree('refresh',$('#dev_netIDs'));
								$('body').oneTime(2000,"netidrefresh",function(){
									$('#devicetree').jstree('refresh',$('#dev_netIDs'));
								});
							}
							ws_util.handleResult(data,status,"","Failed to update button mode");
						},'xml');
						$(this).dialog("close");
					}
				},
				Cancel: function() {
					$(this).dialog("close");
				}
			},
			close: function() {

			}
		});
 	});
};

ws_device.selectAction = function(handle_id){
	if(handle_id == null) return;
	var oldhandle = $('#lmioactions tr.actionselected').attr('handle_id');
	if(oldhandle){
		if(oldhandle != ''){
			if(oldhandle == handle_id){
				// alert("don't do anything");
				return;
			}
			$('#lmioactions tr[handle_id="'+oldhandle+'"]').removeClass('actionselected');
		}
	}
	if(handle_id != null && handle_id !== false){
		$('#lmioactions tr[handle_id="'+handle_id+'"]').addClass('actionselected');
	}
};

ws_device.editAction = function(create)
{
	var selected = $('#lmioactions tr.actionselected');
	if(!create && $(selected).length == 0) return;
	$('#action-form fieldset select option:selected').removeAttr('selected');
	$('#action-form fieldset label:eq(4)').html('Groups:');
	if(_ws.groupData != null){
		var options = '';
		$(_ws.groupData).find('group').each(function(){
			//TODO filter group types
			//if( ws_sched.groupInActionType(actionType, type) ){ // actionType == type){
				var handle = $(this).find('handle').text();
				var name = $(this).find('name').text();
				var description = $(this).find('description').text();
				// todo figure out how to mark selected.
				options+='<option value="'+handle+'" title="'+description+'">'+name+'</option>';
			//}
		});
		$('#action-form fieldset select.groupselector').html(options);
	}
	if($(selected).length == 0){
		$('#action-form').attr('handle_id','');
		$('#action-form').attr('action_name','');
		$( "#actionslider" ).slider({
			value:0,
			min: 0,
			max: 6000,
			step: 1,
			slide: function( event, ui ) {
				$( '#action-form fieldset input:eq(0)' ).val( ui.value );
			}
		});
		$( '#action-form fieldset input:eq(0)').val( $( "#actionslider" ).slider( "value" ) );
	}else{
		$('#action-form').attr('handle_id',$(selected).attr('handle_id'));
		var name=$(selected).find('td:eq(0)').text();
		$('#action-form').attr('action_name',name);
		var action=$(selected ).find('td:eq(1)').text();
		var condition=$(selected ).find('td:eq(2)').text();
		var setpoint=$(selected ).find('td:eq(3)').text();
		var delay=$(selected ).find('td:eq(4)').text();
		$('#action-form fieldset select:eq(0) option[value="'+action+'"]').attr('selected','selected');
		$('#action-form fieldset select:eq(1) option[value="'+condition+'"]').attr('selected','selected');
		//$('#action-form fieldset input:eq(0)').val(setpoint);
		$('#action-form fieldset select:eq(2) option[value="'+delay+'"]').attr('selected','selected');
		$( "#actionslider" ).slider({
			value:setpoint,
			min: 0,
			max: 6000,
			step: 1,
			slide: function( event, ui ) {
				$( '#action-form fieldset input:eq(0)' ).val( ui.value );
			}
		});
		$( '#action-form fieldset input:eq(0)').val( $( "#actionslider" ).slider( "value" ) );
		$(selected).find('td:eq(5) span').each( function() {
			var ghandle = $(this).attr('handle');
			$('#action-form fieldset select.groupselector option[value="'+ghandle+'"]').attr('selected','selected');
		});
	}
	//$( "#dialog:action-form" ).dialog( "destroy" );
 	$(function() {
		$('#action-form').dialog({
			height: 380,
			width: 600,
			modal: true,
			buttons: {
				"Save": function() {
					ws_util.logMessage("Save Called");
					var handle = $('#action-form').attr('handle_id');
					var name = $('#action-form').attr('action_name');
					var action = $('#action-form fieldset select:eq(0) :selected').val();
					var condition = $('#action-form fieldset select:eq(1) :selected').val();
					var delay = $('#action-form fieldset select:eq(2) :selected').val();
					var setpoint = $('#action-form fieldset input:eq(0)').val();
					var xml = _ws.xml;
					xml+="<lmio301 handle=\""+$('#device').attr('deviceID')+"\"><events><event handle=\""+handle+"\">\n\t<name>"+name+"</name><action>"+action+"</action>\n\t<condition>"+condition+"</condition>\n\t<delay>"+delay+"</delay>\n\t<setpoint>"+setpoint+"</setpoint>\n";
					xml+="\t<groups>\n";
					var found = false;
					$('#action-form fieldset select.groupselector option:selected').each( function() {
						xml+= "\t\t<group handle=\""+$(this).val()+"\">"+$(this).text()+"</group>\n";
						found = true;
					});
					xml+="\t</groups>\n</event></events></lmio301>";
					ws_util.logMessage(xml);
					if(found){
						ws_util.post(xml,"Saved","Save Failure",function(result){
							if(result) ws_device.refreshFCEvents();
						});
						$(this).dialog("close");
					}else{
						$('#action-form fieldset label:eq(4)').html('Groups:<span style="color:red;">Required</span>');
					}
				},
				Cancel: function() {
					$(this).dialog("close");
				}
			},
			close: function() {

			}
		});
 	});
};

ws_device.refreshFCEvents = function(){
	$('#sec_fcevents').attr('needsRefresh',1);
	_ws.resetMainTimer();
};

ws_device.addFCEvent = function(data)
{
	var num = $('#lmioactions tr').length;
	$(data).find('event').each(function(){
		var aid = $(this).attr("handle");
		var aname = $(this).find("name").text();
		if(aid == ""){
			aname = num;
			aid = num;
		}
		var action = $(this).find("action").text();
		var condition = $(this).find("condition").text();
		if(condition == "Greater Than") condition="Greater Than";
		else condition = "Less Than";
		var setpoint = $(this).find("setpoint").text();
		var delay = $(this).find("delay").text();
		var grps = '';
		$(this).find('group').each(function(){
			var gname=$(this).text();
			var ghandle=$(this).attr("handle");
			grps += "<span handle=\""+ghandle+"\">"+gname+"</span>";
		});
		var row ="<tr handle_id=\""+aid+"\" class=\"actionlisting\"><td>"+aname+"</td><td>"+action+"</td><td>"+condition+"</td><td>"+setpoint+"</td><td>"+delay+"</td><td style=\"overflow:hidden;\">"+grps+"</td></tr>\n";
		ws_util.logMessage(row);
		var current = $('#lmioactions tr[handle_id="'+aid+'"]');
		if($(current).length > 0){
			$(current).replaceWith(row);
		}else{
			$('#lmioactions').append(row);
		}
	});
	$('#lmioactions tr').click(function() {
		ws_device.selectAction(this.getAttribute('handle_id'));
	});
};

ws_device.removeAllDevices = function(){
	$('#dlg-delete').attr('title','Remove All Devices');
	$(function() {
		$("#del_dlg_msg").text("Are you sure you would like to remove all devices?");
		$("#dlg-delete").dialog({
			resizable: false,
			height:200,
			width:450,
			modal: true,
			buttons: {
				'Delete': function() {
					$(this).dialog('close');
					$.get('/gui?q=deleteAllDevices', function(data) {
						$('.result').html(data);
					});
					$('#devicetree').jstree('destroy');
					$('#devicetree').empty();
					ws_device.needLoading=true;
				},
				'Cancel': function() {
					$(this).dialog('close');
				}
			}
		});
	});
};

ws_device.requestRoomVersions = function(handle){
	var url='/gui?q=updateRoomVersions';
	if(typeof(handle)!="undefined"){
		url='/gui?q=updateRoomVersions&handle='+handle;
	}
	ws_util.get(url, function(data) {
		$('.result').html(data);
		ws_util.statusMessage("Requested Versions...");
	});
};

ws_device.resetRoom = function(handle){
	$('#message-dialog').attr('title',"Reset Room");
 	$('#message-dialog > p > span:eq(1)').text("Are you sure you want to reset the network bridge for this room?");
 	$(function() {
 		$("#message-dialog").dialog({
 			height:200,
 			width:400,
 			modal: true,
 			buttons: {
	 			"Yes": function() {
					ws_util.get('/gui?q=resetRoom&handle='+handle, function(data) {
						$('.result').html(data);
					});
		 			$(this).dialog('close');
		 		},
		 		"No" : function() {
		 			$(this).dialog('close');
		 		}
	 		}
 		});
 	});
};

ws_device.deleteDevice = function(handle){
	$('#message-dialog').attr('title',"Delete Device");
 	$('#message-dialog > p > span:eq(1)').text("Are you sure you want to delete device?");
 	$(function() {
 		$("#message-dialog").dialog({
 			height:200,
 			width:400,
 			modal: true,
 			buttons: {
	 			"Yes": function() {
					ws_util.get('/gui?q=remove&handle='+handle, function(data) {
						$('.result').html(data);
						ws_device.loadDevices();
					});
		 			$(this).dialog('close');
		 		},
		 		"No" : function() {
		 			$(this).dialog('close');
		 		}
	 		}
 		});
 	});

};

ws_device.deleteFCEvent = function(check){
	if(typeof(check) == "undefined") check = true;
	var handle =   $('#lmioactions tr.actionselected').attr('handle_id');
	if(typeof(handle) == "undefined"){
		ws_util.messageDialog("Error","No action");
		return;
	}
	var name = $('#lmioactions tr.actionselected td:eq(0)').text();
	if(check){
		$('#dlg-delete').attr('title','Delete Action - '+name);
		$(function() {
			$("#del_dlg_msg").text("Are you sure you would like to delete action: "+name);
			$("#dlg-delete").dialog({
				resizable: false,
				height:200,
				width:450,
				modal: true,
				buttons: {
					'Delete': function() {
						ws_device.deleteFCEvent(false);
						$(this).dialog('close');
					},
					'Cancel': function() {
						$(this).dialog('close');
					}
				}
			});
		});
	}else{
		$.get('/gui?q=remove&handle='+handle,function(data){
						ws_util.statusMessage('Action Deleted');
						ws_device.refreshFCEvents();
					});
	}
};

ws_device.editGroups = function()
{
	var selnode = $('#selnetgrps');
	if($(selnode).length == 0) return;
	var selgrps = new Array();
	$(selnode).find('option').each( function(){
		selgrps.push($(this).val());
	});
	var formsel = $('#group-form form fieldset select');
	formsel.html('');
	if(_ws.groupData != null){
		$(_ws.groupData).find('group').each(function(){
			var actionType = $(this).find('actionType').text();
			//Network groups should not control level groups or themselves.
			if( ws_sched.groupInActionType(actionType, "Normal/After Hours") && actionType!="networkID" ){
				var handle = $(this).find('handle').text();
				var name = $(this).find('name').text();
				var description = $(this).find('description').text();
				// todo figure out how to mark selected.
				$(formsel).append('<option value="'+handle+'" title="'+description+'"'+($.inArray(handle,selgrps)>=0?' selected="selected"':'')+'>'+name+'</option>');
			}
		});
	}
 	$(function() {
		$('#group-form').dialog({
			height: 380,
			width: 600,
			modal: true,
			buttons: {
				"Save": function() {
					var selnode = $('#selnetgrps');
					var formsel = $('#group-form form fieldset select');
					selnode.html('');
					var xml = _ws.xml;
					xml+="<networkGroup handle=\""+$('#device').attr('deviceID')+"\">\n";
					xml+="\t<state>\n";
					$(formsel).find('option').each( function() {
						if($(this).attr("selected")){
							xml+= "\t\t<link><name>"+$(this).text()+"</name><handle>"+$(this).val()+"</handle><description>"+$(this).attr('title')+"</description><slot>in10</slot>";
							xml+= "</link>\n";
							selnode.append('<option value="'+$(this).val()+'" title="'+$(this).attr('title')+'">'+$(this).text()+'</option>');
						}
					});
					xml+="\t</state></networkGroup>";
					ws_util.logMessage(xml);
					ws_util.post(xml, "Saved","Save Failure", function(result){
						if(result)ws_device.refreshFCEvents();
					});
					$(this).dialog("close");
				},
				Cancel: function() {
					$(this).dialog("close");
				}
			},
			close: function() {

			}
		});
 	});
};

// ====================================== CONFIG =========================================

var ws_config = {}; // config namespace

ws_config.doNothing = 0;

ws_config.isLoading = false;

ws_config.xmlPage = "";

ws_config.discovering = false;

ws_config.logStreamingEnabled = false;

ws_config.lastLogQuery = 0;

ws_config.timezone = "";

ws_config.loadConfig = function()
{
	$.get("/gui/config.xml", function (data){
		ws_config.isLoading = true;
		$(data).find('setting').each(function(){
			var name = $(this).find('name').text();
			var value = $(this).find('value').text();
			if(name == "mainlogoimage"){
				$("#mainlogo").attr('src',value);
			}else if(name == "mainhomeimage"){
				$("#mainPage").css('background-image',"url('"+value+"')");
				if(value != "/ord?file:^gui/images/WattStopperLogo.png"){
					$('#resetImage').show();
				}
			}else if(name == "stationtitle"){
				$('#configSite label:eq(0)').next().val(value);
				$("#stationtitle").text(value);
				document.title=value;
			}else if(name == "version"){
				$("#version").text(value);
			}else if(name == "pollingLimit"){
				if(value >= 2 && value <= 240){
					$('#pollingLimit').val(value);
					_ws.pollingLimit = value;
				}
			}else if(name == "defaultTimeout"){
				if(value >= 2000 && value <= 10000){
					$('#defaultTimeout').val(value);
					_ws.defaultTimeout = value;
				}
			}else if(name == "deviceTimeout"){
				if(value >= 10000 && value <= 30000){
					$('#deviceTimeout').val(value);
					_ws.deviceTimeout = value;
				}
			}else if(name == "sunrise"){
				$("#sunrise").text(value);
			}else if(name == "sunset"){
				$("#sunset").text(value);
			}else if(name == "longitude"){
				$("#configTimezone label:eq(1)").next().val(value);
			}else if(name == "latitude"){
				$("#configTimezone label:eq(0)").next().val(value);
			}else if(name == "timezone"){
				++ws_config.doNothing;
				ws_config.timezone = value;
				$('#zones option[value="'+value+'"]').attr('selected',true);
				--ws_config.doNothing;
			}else if(name == "IRB_REFRESH_TIME"){
				$("#configTuning label:eq(0)").next().val(value);
			}else if(name == "LEASE_DELAY_TIMER"){
				$("#configTuning label:eq(1)").next().val(value);
			}else if(name == "xmlpxpage"){
				ws_config.xmlPage = value;
				ws_config.loadExternalLinks();
			} else if (name == "bacnetExportEnabled") {
				_ws.exportConfiguration = value.toLowerCase() == "true" ? true : false;
			}
		});
		ws_config.isLoading = false;
		$('#configNetwork input[type="text"]').keyup(function(){
			ws_config.testNetwork();
		});
		$('#configNetwork input[type="text"]').change(function(){
			ws_config.testNetwork();
		});
		$('#discoverRange input[type="text"]').keyup(function(){
			ws_config.testDiscoverRange();
		});
		$('#discoverRange input[type="text"]').change(function(){
			ws_config.testDiscoverRange();
		});
	});
	$('#configwin label').addClass('configLabels');
};

$.fn.dataTableExt.oApi.fnAddDataAndDisplay = function ( oSettings, aData )
{
    /* Add the data */
    var iAdded = this.oApi._fnAddData( oSettings, aData );
    var nAdded = oSettings.aoData[ iAdded ].nTr;

    /* Need to re-filter and re-sort the table to get positioning correct, not perfect
     * as this will actually redraw the table on screen, but the update should be so fast (and
     * possibly not alter what is already on display) that the user will not notice
     */
    this.oApi._fnReDraw( oSettings );

    /* Find it's position in the table */
    var iPos = -1;
    for( var i=0, iLen=oSettings.aiDisplay.length ; i<iLen ; i++ )
    {
        if( oSettings.aoData[ oSettings.aiDisplay[i] ].nTr == nAdded )
        {
            iPos = i;
            break;
        }
    }

    /* Get starting point, taking account of paging */
    if( iPos >= 0 )
    {
        oSettings._iDisplayStart = ( Math.floor(i / oSettings._iDisplayLength) ) * oSettings._iDisplayLength;
        this.oApi._fnCalculateEnd( oSettings );
    }

    this.oApi._fnDraw( oSettings );
    return {
        "nTr": nAdded,
        "iPos": iAdded
    };
};

ws_config.updateLoggingParameters = function(json) {
	ws_config.lastLogQuery = json.last;
	$('#configLogging > label:eq(0) > input').attr('checked',json.enableBacnetLogging);
	$('#configLogging > label:eq(1) > input').attr('checked',json.enableBIRBCommLogging);
};

ws_config.loadNewLogEntries = function()
{
	if ($("#logStreamingEnabled").is(':checked')) {

		$.get("/gui/applicationDirectorLog.json?heartbeat=true&last=" + ws_config.lastLogQuery, function(data) {
			ws_config.updateLoggingParameters(data);
			for (entry in data.aaData) {
				var potentialData = data.aaData[entry];
				$("#loggingTable").dataTable().fnAddDataAndDisplay( potentialData );
			}
		});
	}
};

ws_config.logStreaming = function()
{
	$("#loggingTable").dataTable(
		{
			"bDestroy": true,
			"bRetrieve": true,
			"fnInitComplete": function(oSettings, json) {
				ws_config.updateLoggingParameters(json);
				$("#loggingTable").dataTable().fnSort([ [0, 'desc']]);
				$("#loggingTable").width("100%");
			},
			"sPaginationType": "full_numbers",
			"iDisplayLength": 25,
			"aLengthMenu": [25, 50, 100, 10],
			"bProcessing": true,
			"sAjaxSource": '/gui/applicationDirectorLog.json',
			"aoColumnDefs" : [
			    { "sWidth": "11.5em", "aTargets": [ 0 ] },
			    { "sType": "html", "aTargets": [ 0, 1 ] },
			    { "bVisible": false, "aTargets": [ 2 ] },
			    { "iDataSort": 2, "aTargets": [ 1 ] },
			    { "asSorting": ["desc"], "aTargets": [ 1 ] }

			]

		}
	);

};

ws_config.updateTime = function()
{
	ws_util.get("/gui/systemTime.xml", function(data){
		$('#logininfo span').text($(data).find('user').text());
		$('#current_time').text($(data).find('time').text());
	});
};

ws_config.checkTextValue = function(handle,field) {
	
	//check against regex
	var regex = ws_grp.regexPatterns.validdevicename.regex;
	var text = field.value;	
	if (regex.test(text)) {
		$(jq(handle+ "-" + field.name+'error')).empty();		
	} else {
		var errorMsg = ws_grp.regexPatterns.validdevicename.message;
		$(jq(handle + "-" + field.name+'error')).text(errorMsg);	
	}	
};

ws_config.updateValue = function(handle, name, field){
	_ws.resetMainTimer();
	if(typeof(field) == "string" || field instanceof String){
		$.get('/gui?q=update&handle='+handle+'&name='+encodeURIComponent(name)+'&value='+encodeURIComponent(field), null, function(data,status) {
			ws_util.handleResult(data,status,"","Failed to update value ("+name+")");
		},'xml');
	}else{
		$.get('/gui?q=update&handle='+handle+'&name='+encodeURIComponent(name)+'&value='+encodeURIComponent(field.value), null, function(data,status) {
			ws_util.handleResult(data,status,"","Failed to update value ("+name+")");
		},'xml');
	}
};

ws_config.resetImageToLogo = function(){
	ws_config.updateConfig("mainhomeimage", "/ord?file:^gui/images/WattStopperLogo.png",function(result){if(result){window.location.reload(true);}});
};

ws_config.updateNetwork = function(name, value){
	// alert(name+" - "+value);
	ws_util.logMessage('/gui?q=updateNetwork&name='+encodeURIComponent(name)+'&value='+encodeURIComponent(value));
	$.get('/gui?q=updateNetwork&name='+encodeURIComponent(name)+'&value='+encodeURIComponent(value), null, function(data,status) {
		ws_util.handleResult(data,status,"","Failed to update network value ("+name+")");
	},'xml');
};

ws_config.updatePollingLimit = function(){
	var value = $('#pollingLimit').val();
	if(value >= 2 && value <= 240){
		_ws.pollingLimit = value;
		ws_config.updateConfig("pollingLimit",value);
	}
};

ws_config.updateDefaultTimeout = function(){
	var value = $('#defaultTimeout').val();
	if(value >= 2000 && value <= 10000){
		_ws.defaultTimeout = value;
		ws_config.updateConfig("defaultTimeout",value);
	}
};

ws_config.updateDeviceTimeout = function(){
	var value = $('#deviceTimeout').val();
	if(value >= 10000 && value <= 30000){
		_ws.deviceTimeout = value;
		ws_config.updateConfig("deviceTimeout",value);
	}
};

ws_config.updateConfig = function(key, value, handlefunc){
	if(ws_config.isLoading)return;
	$.get('/gui?q=updateconfig&key='+encodeURIComponent(key)+'&value='+encodeURIComponent(value), null, function(data,status) {
		ws_util.handleResult(data,status,"","Failed to update config value ("+key+")",handlefunc);
	},'xml');
};
ws_config.setTimeZones = function(responseText, textStatus, XMLHttpRequest)
{
	if (ws_config.timezone != ""){
		$('#zones option[value="'+ws_config.timezone+'"]').attr('selected',true);
	}
};

ws_config.loadTimeZones = function()
{
	$('#zoneholder').load('/ord?file:^gui/timezone-min.xml',null,ws_config.setTimeZones);
};

ws_config.updatedTimezone = function()
{
	$('#saveTimezone').attr('disabled',false);
};

ws_config.setTimezone = function()
{
	if(ws_config.doNothing > 0) return;
	ws_util.statusMessage("Setting Timezone");
	tz = $('#zones :selected').val();
	ws_config.updateConfig('TIMEZONE',tz, function(result){if(result){window.location="/ord?file:^gui/loading.html";}});
	$('#saveTimezone').attr('disabled',true);
};

ws_config.setImageFilename = function()
{
	var types = [ 'jpg','jpeg','bmp','gif','png'];
	var filename = $('#logofield').val();
	var loc = filename.lastIndexOf('.');
	if(loc > 0){
		var extension = filename.substr(loc+1);
		if( $.inArray(extension,types) >= 0){
			//good
			filename = filename.replace(' ','_');
		}else{
			ws_util.messageDialog("ERROR","Invalid filename. Must be an image of type '*.jpg','*.jpeg','*.gif','*.bmp','*.png'");
			$('#logofield').val('');
		}
	}else{
		ws_util.messageDialog("ERROR","Invalid filename. Must be an image of type '*.jpg','*.jpeg','*.gif','*.bmp','*.png'");
		$('#logofield').val('');
	}
	$('#logoname').val( filename );
};

ws_config.setSystemTime = function()
{
	var date = $('#configTime .datepicker3').val();
	var time = $('#configTime > label:eq(1)').next();
	var hour = $(time).find('select:eq(0) :selected').val();
	var min  = $(time).find('select:eq(1) :selected').val();
	var type = $(time).find('select:eq(2) :selected').val();
	re = /(\d\d)\/(\d\d)\/(\d\d\d\d)/;
	if(type == "am"){
		if(hour == 12) hour = 0;
	}else{
		if(hour < 12) hour = (hour * 1) + 12;
	}
	var dstr = date.replace(re, "$3-$1-$2") + "T" + ws_util.pad(hour,2) + ":" + ws_util.pad(min,2) + ":00Z";
	// alert(dstr);
	ws_config.updateConfig("SYSTIME",dstr);
};

ws_config.refresh = function(){
	switch ($('#configlist :selected').val()){
	case 'configDiscovery':
		ws_config.getDiscoveryStatus();
		break;
	case 'configSystemInfo':
		ws_config.loadPlatformInfo();
		break;
	case 'configBootloadFirmware':
		ws_config.loadBootloadStatus();
		break;
	case 'configLogging':
		ws_config.loadNewLogEntries();
	}
};

ws_config.select = function()
{
	var name = $('#configlist :selected').val();
	if($("#"+name).length < 1 ){
		alert("Cannot find my div:"+name);
	}
	//ws_util.statusMessage(name,2000);
	if( $("#configwin > div:visible").length > 0 ){
		if( $("#configwin > div:visible").attr("id") != name){
			$("#configwin > div:visible").hide();
		}else{
			return;
		}
	}
	switch(name){
		case 'configUserManagement':
			$('#editUser').hide();
			ws_config.loadUsers();
			break;
		case 'configLogging':
			_ws.resetMainTimer(2);
			ws_config.logStreaming();
	}
	$("#"+name).show();
};

ws_config.switchConfig = function(name){
	$('#configlist div.configSelected').each(function(){
		var visname = $(this).attr('name');
		if(visname){
			if(visname != ''){
				//alert("found "+visname);
				if(visname == name){
					//alert("don't do anything");
					return;
				}
				//alert("Deactivating "+visname);
				$("#"+visname+":visible").hide(0);
				$('#configlist div[name="'+visname+'"]').removeClass('configSelected');
			}
		}
	});
	$('#configlist div[name="'+name+'"]').addClass('configSelected');
	$("#"+name+":hidden").show(0);
};

ws_config.loadPlatformInfo = function(){
	ws_util.get("/gui/platform.xml", function (data){
		ws_config.setPlatformInfo(data);
	});
};

ws_config.setPlatformInfo = function(data){
	// if($( "#tabs" ).tabs( "option", "selected" ) != 4) return;
	var cpu = $(data).find('cpu').text();
	var mem = $(data).find('physicalMemory').text();
	var free = $(data).find('free').text();
	var percent = (Math.floor(free/mem*1000)/10.0);
	var label3 = $('#configSystemInfo > label:eq(3)');
	if(label3.length > 0){
		$(label3).next().text(free);
		$(label3).next().next().text(mem);
		$(label3).next().next().next().text(percent);
	}
	$('#configSystemInfo > label:eq(4)').next().text(cpu);
};

ws_config.setNetworkInfo = function(en0, en1)
{
	if($(en0).length < 1) {ws_util.statusMessage("cannot find en0");return;}
	if($(en1).length < 1) {ws_util.statusMessage("cannot find en1");return;}
	ws_config.setIpData( $('#configNetwork > label:eq(1)').next('div'),$(en0).find('ipAddress').text());
	ws_config.setIpData( $('#configNetwork > label:eq(2)').next('div'),$(en0).find('subnetMask').text());
	ws_config.setIpData( $('#configNetwork > label:eq(3)').next('div'),$(en0).find('defaultGateway').text());
	$('#configNetwork > label:eq(0)').next('div').text($(en0).find('MAC').text());
	ws_config.setDNSData($(en0).find('dnsServer').text());
	ws_config.setIpData( $('#configNetwork > label:eq(5)').next('div'),$(en1).find('ipAddress').text());
	ws_config.setIpData( $('#configNetwork > label:eq(6)').next('div'),$(en1).find('subnetMask').text());
	ws_config.testNetwork(false);
};

ws_config.getNetworkInfo = function()
{
	var networks = [];
	networks['en0']=[];
	networks['en1']=[];
	networks['en0']['ipAddress']     =ws_config.getIpData($('#configNetwork > label:eq(1)').next('div'));
	networks['en0']['subnetMask']    =ws_config.getIpData($('#configNetwork > label:eq(2)').next('div'));
	networks['en0']['defaultGateway']=ws_config.getIpData($('#configNetwork > label:eq(3)').next('div'));
	networks['en0']['dnsServers']     =ws_config.getDNSData();
	networks['en1']['ipAddress']     =ws_config.getIpData($('#configNetwork > label:eq(5)').next('div'));
	networks['en1']['subnetMask']    =ws_config.getIpData($('#configNetwork > label:eq(6)').next('div'));
	return networks;
};

ws_config.saveNetwork = function()
{
	var networks = ws_config.getNetworkInfo();
	if(ws_config.validateNetwork(networks)){
		var xml = _ws.xml;
		xml+="<updateNetworkSettings>\n";
		xml+="\t<en0IpAddress>"+networks['en0']['ipAddress']+"</en0IpAddress>\n";
		xml+="\t<en0SubnetMask>"+networks['en0']['subnetMask']+"</en0SubnetMask>\n";
		xml+="\t<en0DefaultGateway>"+networks['en0']['defaultGateway']+"</en0DefaultGateway>\n";
		xml+="\t<en0DNSServers>\n";
		var servers = networks['en0']['dnsServers'];
		if(servers != null){
			for(var x=0;x<servers.length;x++){
				xml+="\t\t<server>"+servers[x]+"</server>\n";
			}
		}
		xml+="\t</en0DNSServers>\n";
		xml+="\t<en1IpAddress>"+networks['en1']['ipAddress']+"</en1IpAddress>\n";
		xml+="\t<en1SubnetMask>"+networks['en1']['subnetMask']+"</en1SubnetMask>\n";
		xml+="</updateNetworkSettings>";
		ws_util.logMessage(xml);
		ws_util.post(xml,"Saved","Failed to Save Network Settings",function(result){
			//$('#saveNetworkBtn').attr('disabled',true);
			window.location = '/ord?file:^gui/loading.html';
		});
	}
};

ws_config.setDNSData = function(source)
{
	var dns = "";
	$(source).each(function(){
		if(dns.length > 0){
			dns += ","+$(this).text();
		}else{
			dns = $(this).text();
		}
	});
	$("#dnsservers").val(dns);
};

ws_config.getDNSData = function()
{
	var servers = $("#dnsservers").val();
	if(servers == "")return null;
	servers = servers.split(',');
	for(var x=0;x<servers.length;x++){
		servers[x]=servers[x].trim();
	}
	if(servers.length == 0) return null;
	return servers;
};

ws_config.isNumber = function(val)
{
	var re = /^([1-4][0-9]{6}|[0-9]{1,6})$/;
	if(re.test(val)) return true;
	else return false;
};

ws_config.checkIP = function(addr)
{
	var re = /^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})$/;
	if(re.test(addr)) return true;
	else return false;
};

ws_config.checkMASK = function(addr)
{
	var re = /^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})$/;
	if(re.test(addr)) return true;
	else return false;
};

ws_config.getIPNums = function(addr)
{
	var re = /^((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\.){3}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})$/;
	var match = re.exec(addr);
	return match;
};

ws_config.get8BitString = function(num)
{
	var bits = "";
	for(var i=7;i>=0;i--){
		bits += ( ((1<<i) & num) > 0) ? "1" : "0";
	}
	return bits;
};

ws_config.getIpBitString = function(addr)
{
	var bits = "";
	if(ws_config.checkIP(addr)){
		var nums = addr.split('.');
		bits += ws_config.get8BitString(nums[0]);
		bits += ws_config.get8BitString(nums[1]);
		bits += ws_config.get8BitString(nums[2]);
		bits += ws_config.get8BitString(nums[3]);
	}else{
		//TODO Should throw here really
		return null;
	}
	return bits;
};

ws_config.getIpRange = function(addr,mask)
{
	var range= new Array( new Array(0,0,0,0),new Array(0,0,0,0));
	addr=addr.split('.');
	mask=mask.split('.');
	for(var i=0;i<4;i++){
		//ws_util.logMessage("range[0]="+addr[i]+" & "+mask[i]+" & 0xFF");
		range[0][i]=(addr[i] & mask[i]) & 0xFF;
		range[1][i]=( (addr[i] & mask[i]) | (mask[i] ^ 0xFF) ) & 0xFF;
	}
	return range;
};

ws_config.getMaskBits = function(mask)
{
	var numbits=0;
	if(ws_config.checkMASK(mask)){
		var looking = true;
		var nums = mask.split('.');
		for(var i=0;i<4;i++){
			var bits = ws_config.get8BitString(nums[i]);
			for(var j=0;j<8;j++){
				if(looking){
					if(bits[j]=="1"){
						numbits++;
					}else{
						looking = false;
					}
				}else{
					if(bits[j]=="1"){
						return -1;
					}
				}
			}
		}
	}else{
		return -1;
	}
	return numbits;
};

ws_config.testNetwork = function(enableButton)
{
	if(typeof(enableButton)== 'undefined'){
		enableButton = true;
	}
	var networks = ws_config.getNetworkInfo();
	if(ws_config.validateNetwork(networks)){
		if(enableButton)$('#saveNetworkBtn').attr('disabled',false);
		else $('#saveNetworkBtn').attr('disabled',true);
	}else{
		$('#saveNetworkBtn').attr('disabled',true);
	}
	//alert(networks['en0']['ipAddress']);
};

ws_config.validateNetwork = function(networks)
{
	$('#dnsmsg').empty();
	$('#maskmsg').empty();
	$('#maskmsg2').empty();
	$('#netspan').empty();
	// validate network 0
	var addrBits = ws_config.getIpBitString(networks['en0']['ipAddress']);
	var maskNumBits = ws_config.getMaskBits(networks['en0']['subnetMask']);
	var gatewayBits = ws_config.getIpBitString(networks['en0']['defaultGateway']);
	var maskNumBits2 = ws_config.getMaskBits(networks['en1']['subnetMask']);
	if(addrBits == null || maskNumBits == null || gatewayBits == null || maskNumBits2 == null){
		$('#netstatus').html("Address and Mask fields may not be empty");
		return false;
	}
	if(maskNumBits > 0){
		var range = ws_config.getIpRange(networks['en0']['ipAddress'], networks['en0']['subnetMask']);
		$('#netspan').html(''+"Valid Range:"+range[0].join('.')+" - "+range[1].join('.'));
		if(addrBits.substring(0,maskNumBits) == gatewayBits.substring(0,maskNumBits)){
		}else{
			$('#netstatus').html("Invalid Network Setting");
			return false;
		}
	}else{
		$('#netstatus').html("Invalid Network Setting");
		$('#maskmsg').html("Mask Invalid");
		return false;
	}
	var servers = networks['en0']['dnsServers'];
	if(servers != null){
		for(var x=0;x<servers.length;x++){
			if(!ws_config.checkIP(servers[x])){
				$('#netstatus').html("Invalid Network Setting");
				$('#dnsmsg').html('Invalid dns entry. Must be #.#.#.#[,#.#.#.#]...');
				return false;
			}
		}

	}
	//validate network 1
	if(maskNumBits2 > 0){
		if(networks['en0']['ipAddress'] == networks['en1']['ipAddress']){
			$('#netstatus').html("IP Addresses May Not Match");
			return false;
		}
		// validate that network 2 is not same as network 1
	}else{
		$('#netstatus').html("Invalid Network Setting");
		$('#maskmsg2').html("Mask Invalid");
		return false;
	}
	$('#netstatus').empty();
	return true;
};

ws_config.setIpData = function(dest, addr)
{
	$(dest).find('input:eq(0)').val("");
	$(dest).find('input:eq(1)').val("");
	$(dest).find('input:eq(2)').val("");
	$(dest).find('input:eq(3)').val("");
	if($(dest).length < 1) { alert("cannot find IpData dest");return;}
	//$(dest).prepend("***");
	if(ws_config.checkIP(addr)){
		var nums = addr.split('.');
		$(dest).find('input:eq(0)').val(nums[0]);
		$(dest).find('input:eq(1)').val(nums[1]);
		$(dest).find('input:eq(2)').val(nums[2]);
		$(dest).find('input:eq(3)').val(nums[3]);
	}
};

ws_config.getIpData = function(fld)
{
	var addr = [];
	addr[0]=$(fld).find('input:eq(0)').val();
	addr[1]=$(fld).find('input:eq(1)').val();
	addr[2]=$(fld).find('input:eq(2)').val();
	addr[3]=$(fld).find('input:eq(3)').val();

	return addr.join('.');
};

ws_config.reloadDiscoveryReport = function(){
	// if($( "#tabs" ).tabs( "option", "selected" ) != 4) return;
	$.get("/gui/discoverreport.xml", function (data){
		var accordionOptions = { autoHeight: false }; //event: 'mouseover', collapsible: true
		$('#discoveryResultsOuter').remove(); //this gets around the accordian bug where you can't add. So we recreate the dom each time. Less than effecient, but it'll do.
		
		$('#configDiscovery').append('<div id="discoveryResultsOuter"></div>');
		
		if (data.indexOf("WhoIs") >= 0) {
			$.ajax({
				
				url: "/gui/health.json",
				success: function (health_data) {
			
					//Networks
					$('#discoveryResultsOuter').append('<h3><a href="#">WhoIs Network Responses</a></h3><div><table id="discoveryWhoisNetworkTable"></table></div>');								
					var networkTable = $('#discoveryWhoisNetworkTable').dataTable(
						{
							"bProcessing": true,						
							"bDestroy" : true,
			                "sDom" : 'T<"clear">lfrtip',
			                "bSortClasses": false,
			                "oTableTools" : {
			                	"sSwfPath" : "/ord?file:^gui/media/swf/copy_csv_xls_pdf.swf"
			                },
			                "aoColumns": [
			                	{ 'sTitle': "Network #" },
			                	{ 'sTitle': "Devices Found" },
			                	{ 'sTitle': "Status" },
			                	{ 'sTitle': "Max Device Count"}, //,'sClass':"WhoIsMaxDC" },
			                	{ 'sTitle': "Min Device Count"}, //,'sClass':"WhoIsMinDC" },
			                	{ 'sTitle': "Devices Needing Upgrade"} //, 'sClass':'WhoIsDNU' }
			                ],
			                "aaData": health_data.networks
					});
					// set tooltips for columns
				    //$('.WhoIsMaxDC').attr('title','Max devices reported seen by bridges on network (incl. SegMan or router)');
				    //$('.WhoIsMinDC').attr('title','Minimum devices reported seen by bridges on network (incl. SegMan or router)');
				    //$('.WhoIsDNU').attr('title','Number of bridges which need upgrading to support network health monitoring');
	
					networkTable.$('td').hover(function() {
				        var iCol = $('td', this.parentNode).index(this) % 6;
				        $('td:nth-child('+(iCol+1)+')', networkTable.$('tr')).addClass( 'highlighted' );
				    }, function() {
				        networkTable.$('td.highlighted').removeClass('highlighted');
				    } );
					
					networkTable.$('td').each(function() {
						var iCol = $('td', this.parentNode).index(this) % 6;
						//ADD MORE TOOLTIPS HERE
						if (iCol + 1 == 6) {
							this.setAttribute('title','Number of network bridges that need upgrading to support network health monitoring');						
						}else if( iCol+1 == 5){
							this.setAttribute('title','Minimum devices reported seen by bridges on network (incl. SegMan or router)');
						}else if( iCol+1 == 4){
							this.setAttribute('title','Max devices reported seen by bridges on network (incl. SegMan or router)');
						}
					});
					
					//Devices
					$('#discoveryResultsOuter').append('<h3><a href="#">WhoIs Device Responses</a></h3><div><table id="discoveryWhoisDeviceTable"></table></div>');							
					var deviceTable = $('#discoveryWhoisDeviceTable').dataTable(
						{
							"bProcessing": true,						
							"bDestroy" : true,
			                "sDom" : 'T<"clear">lfrtip',
			                "oTableTools" : {
			                	"sSwfPath" : "/ord?file:^gui/media/swf/copy_csv_xls_pdf.swf"
			                },
			                "aoColumns": [
			                	{ 'sTitle': "Network #" },		                	
			                	{ 'sTitle': "MAC Address" },
			                	{ 'sTitle': "BACnet ID" },
			                	{ 'sTitle': "Model Name" },
			                	{ 'sTitle': "F/W Version" },
			                	{ 'sTitle': "Name" },
			                	{ 'sTitle': "Description" },
			                	{ 'sTitle': "Network Fault"}, //, 'sClass':'WhoIsNF' },
			                	{ 'sTitle': "Device Count"} //, 'sClass':'WhoIsDC' }
			                ],
			                "aaData": health_data.items
					});
					deviceTable.$('td').hover(function() {
				        var iCol = $('td', this.parentNode).index(this) % 9;
				        $('td:nth-child('+(iCol+1)+')', deviceTable.$('tr')).addClass( 'highlighted' );
				    }, function() {
				        deviceTable.$('td.highlighted').removeClass('highlighted');
				    } );
					//$('.WhoIsNF').attr('title','Has a network fault been detected by the network bridge');
					//$('.WhoIsDC').attr('title','Number of devices detected by network bridge. (Incl. SegMan or router)');
					deviceTable.$('td').each(function() {
						var iCol = $('td', this.parentNode).index(this) % 9;
						//ADD MORE TOOLTIPS HERE
						if (iCol + 1 == 8){
							this.setAttribute('title','Has a network fault been detected by the network bridge');
						} else if (iCol + 1 == 9){
							this.setAttribute('title','Number of devices detected by network bridge. (Incl. SegMan or router)');
						}
					});																	
				},
				async: false
			});
		}
		//discovery tab goes last!
		$('#discoveryResultsOuter').append('<h3><a href="#">Discovery Report</a></h3><div><pre id="discoveryReport"></pre></div>');		
		$('#discoveryReport').text(data);		
		$('#discoveryResultsOuter').accordion(accordionOptions);

	});
	
	
};

ws_config.resetDiscoverRange = function(){
	$('#discoverRange input:eq(0)').val(0);
	$('#discoverRange input:eq(1)').val(4194302);
};

ws_config.testDiscoverRange = function(){
	ws_util.logMessage("testDiscoveryRange");
	var min = $('#discoverRange input:eq(0)').val();
	var max = $('#discoverRange input:eq(1)').val();
	if(!ws_config.isNumber(min)){
		$('#discoverRange span').text("Invalid value for Min [0-4194302]");
		return false;
	}
	if(!ws_config.isNumber(max)){
		$('#discoverRange span').text("Invalid value for Max [0-4194302]");
		return false;
	}	
	min=Math.abs(min);
	max=Math.abs(max);
	if(min > max){
		$('#discoverRange span').text("Invalid value for Min-Max. Min must be less than or equal to Max");
		return false;
	}
	if(max < 0 || max > 4194302){
		$('#discoverRange span').text("Invalid value for Max [0-4194302]");
		return false;
	}
	if(min < 0 || min > 4194302){
		$('#discoverRange span').text("Invalid value for Max [0-4194302]");
		return false;
	}
	$('#discoverRange span').text("");
	return true;
};

ws_config.customDiscovery = function(startRange,endRange){
	$('#discoverRange input:eq(0)').val(startRange);
	$('#discoverRange input:eq(1)').val(endRange);
	if(!ws_config.testDiscoverRange()){
		ws_util.messageDialog("ERROR", "Invalid Range for discovery");
		return;
	}
	ws_config.getDiscoveryStatus(ws_config._doCustomDiscovery );
};

ws_config._doCustomDiscovery = function(currentDiscoveryStatus){
	if(currentDiscoveryStatus == ""){
		$( "#tabs" ).tabs('select',4); // 4 is id of config tab
		$( "#configlist" ).val("configDiscovery");
		ws_config.doDiscover();
	}else{
		ws_util.messageDialog("ERROR", "Discovery already in progress");
	}
};

ws_config.getDiscoveryStatus = function(processFunc){
	// if($( "#tabs" ).tabs( "option", "selected" ) != 4) return;
	ws_util.get("/gui/discoverstatus.xml",
		function (data){
			var value = $(data).find('value').text();
			var inprocess = false;
			if(value != '') inprocess=true;
			if(inprocess){
				ws_config.discovering = true;
				// $('#configDiscovery input[value="Stop"]').removeAttr('disabled');
				if(!$('#configDiscovery input[value="Discover"]').attr('disabled')){
					$('#configDiscovery input[value="Stop"]').attr('disabled',false);
					$('#configDiscovery input[value="Discover"]').attr('disabled',true);
					$('#configDiscovery input[value="Find New Devices"]').attr('disabled',true);
					$('#configDiscovery input[value="Reload All Devices"]').attr('disabled',true);
					$('#configDiscovery input[value="Network Health"]').attr('disabled',true);
					ws_device.loadDevices('architectural');
				}
			}else{
				if($('#configDiscovery input[value="Discover"]').attr('disabled')){
					$('#configDiscovery input[value="Stop"]').attr('disabled',true);
					$('#configDiscovery input[value="Discover"]').attr('disabled',false);
					$('#configDiscovery input[value="Find New Devices"]').attr('disabled',false);
					$('#configDiscovery input[value="Reload All Devices"]').attr('disabled',false);
					$('#configDiscovery input[value="Network Health"]').attr('disabled',false);
					ws_config.reloadDiscoveryReport();
				}
			}
			$('#configDiscovery span:eq(0)').text(value);
			if(typeof(processFunc) == "function"){
				processFunc(value);
			}
		});
};

ws_config.doLMBCUpgradeFirmware = function(handle)
{
	var url;
	if(handle === "undefined"){
		url='/gui?q=LMBCUpgradeFirmware';
	}else{
		url='/gui?q=LMBCUpgradeFirmware&handle='+handle;
	}
	$.get(url, function(data,status) {
		ws_util.handleResult(data,status,"","Failed to send firmware upgrade request");
		_ws.resetMainTimer();
	});
};

ws_config.doLMBCInstallFirmware = function()
{
	$.get('/gui?q=LMBCInstallFirmware', function(data,status) {
		ws_util.handleResult(data,status,"","Failed to send firmware install request");
		_ws.resetMainTimer();
	});
};

ws_config.doLMBCStopBootload = function()
{
	$.get('/gui?q=LMBCStopBootload', function(data,status) {
		ws_util.handleResult(data,status,"","Failed to send stop bootload request");
		_ws.resetMainTimer();
	});
};

ws_config.loadBootloadStatus = function()
{
	ws_util.get("/gui/bootloadstatus.xml", function(xml){
		var version = $(xml).find('firmwareVersion').text();
		var count = $(xml).find('bootQueue').attr('size');
		$('#lmbc_ver').text(version);
		var queue = '';
		$(xml).find('bootItem').each(function(){
			var name = $(this).find('name').text();
			var descr = $(this).find('description').text();
			var status = $(this).find('status').text();
			queue += descr+" ("+name+") - "+status+"<br/>";
		});
		$('#bootloadqueue').html(queue);
		if(count > 0){
			if($('#configBootloadFirmware input[value="Stop"]').attr('disabled')){
				$('#configBootloadFirmware input[value="Stop"]').attr('disabled',false);
				$('#configBootloadFirmware input[value="LMBC Upgrade Firmware"]').attr('disabled',true);
				$('#configBootloadFirmware input[value="LMBC Install Firmware"]').attr('disabled',true);
			}
		}else{
			if($('#configBootloadFirmware input[value="LMBC Upgrade Firmware"]').attr('disabled')){
				$('#configBootloadFirmware input[value="Stop"]').attr('disabled',true);
				$('#configBootloadFirmware input[value="LMBC Upgrade Firmware"]').attr('disabled',false);
				$('#configBootloadFirmware input[value="LMBC Install Firmware"]').attr('disabled',false);
			}
		}
	});
};

ws_config.loadBootloadReport = function() {
	$('#bootloadResultsOuter').load("/gui/bootload.log").show();
};

ws_config.selectAllNetworks = function() {
	var checked = $("#allnets").attr('checked') == 'checked';
	if (checked) {
		$('#dnets input').each(function(){
			$(this).attr('checked','checked');
			$(this).attr('disabled','disabled');
		});
	} else {
		$('#dnets input').each(function(){
			$(this).attr('disabled',null);
		});
	}
};

ws_config.doCommonDiscover = function(url) {
	if(!ws_config.testDiscoverRange()){
		ws_util.messageDialog("Invalid Range", "Correct Range before running discovery");
		return;
	}
	var min = Math.abs($('#discoverRange input:eq(0)').val());
	var max = Math.abs($('#discoverRange input:eq(1)').val());
	$('#devicetree').jstree('destroy');
	$('#devicetree').empty();
	$('#device').html("");
	$('.result').html("");
	if(min != 0 || max != 4194302){
		url= url + '&low='+min+'&high='+max;
	}
	var allnets = $('#allnets').is(':checked');
	url= url + '&all='+(allnets == true ?'true':'false');
	var dnets = _ws.getDnets();
	if(dnets.length == 0){
		alert("Must select a destination network to discover");
		return;
	} else {
		$.each(dnets,function(i,v){
			url=url+'&nets[]='+v;
		});
	}
	$.get(url, function(data) {
		$('.result').html(data);
	});
	$('#discoveryResultsOuter').hide();
	_ws.resetMainTimer();
};

ws_config.doDiscover = function(){
	ws_config.doCommonDiscover('/gui?q=discover');
};

ws_config.doDiscoverNew = function(){
	ws_config.doCommonDiscover('/gui?q=discoverNew');
};

ws_config.doWhoIs = function(){
	ws_config.doCommonDiscover('/gui?q=whois');
};

ws_config.doReloadAllDevices = function(){
	if(!ws_config.testDiscoverRange()){
		ws_util.messageDialog("Invalid Range", "Correct Range before running discovery");
		return;
	}
	var min = Math.abs($('#discoverRange input:eq(0)').val());
	var max = Math.abs($('#discoverRange input:eq(1)').val());
	$('#devicetree').jstree('destroy');
	$('#devicetree').empty();
	$('#device').html("");
	ws_device.needLoading=true;
	url = '/gui?q=discoverResetAll';
	if(min != 0 || max != 4194302){
		url= url + '&low='+min+'&high='+max;
	}
	$.get(url, function(data) {
		$('.result').html(data);
	});
	_ws.resetMainTimer();
};

ws_config.doStopDiscover = function()
{
	$.get('/gui?q=discoverStop', function(data) {
		$('.result').html(data);
		_ws.resetMainTimer();
	});
};

ws_config.linkClick = function()
{
	var selected = $('#configSite select option:selected');
	if($(selected).length > 0){
		$('#configSite input:eq(1)').val($(selected).text());
		$('#configSite input:eq(2)').val($(selected).val());
		$('#configSite input:eq(3)').attr("checked",$(selected).attr('window')=="true");
	}else{
		ws_config.linkNew();
	}
};

ws_config.linkNew = function()
{
	$('#configSite select option:selected').removeAttr('selected');
	$('#configSite input:eq(1)').val("");
	$('#configSite input:eq(2)').val("");
	$('#configSite input:eq(3)').attr("checked",false);
};
ws_config.loadExternalLinks = function (skip)
{
	if(typeof(skip) == "undefined") skip = false;
	$.get(ws_config.xmlPage, function (xml){
		var options = '';
		$(xml).find('item').each(function(){
			var label = $(this).attr('label');
			var lvalue = $(this).attr('data');
			var window = $(this).attr('window') == "true" ? "true": "false";
			options += '<option value="'+decodeURIComponent(lvalue)+'" window="'+window+'">'+decodeURIComponent(label)+'</option>';
		});
		if(options != ''){
			if(!skip) $('#externalLinksConfig').html(options);
			var externalSelect = '<span class="links">Links</span><br/>';
			externalSelect += '<select id="externalRefs" onclick="ws_util.gotoExternalLink();" size="4">';
			externalSelect += options;
			externalSelect += "</select>";
			oldselect=$("#externalLinks").html();
			if(oldselect == externalSelect){
				// skip
			}else{
				$("#externalLinks").html(externalSelect);
			}
		}
	});
};

ws_config.linkSave = function(){
	var selected = $('#configSite select option:selected');
	var val = $('#configSite input:eq(2)').val();
	var descr = $('#configSite input:eq(1)').val();
	var window = $('#configSite input:eq(3)').attr('checked')?"true":"false";
	if($(selected).length > 0){
		$(selected).text(descr);
		$(selected).val(val);
		$(selected).attr('window',window);
	}else{
		var option = '<option value="'+val+'" window="'+window+'">'+descr+'</option>';
		$('#configSite select').append(option);
	}
	$('#configSite select').val(val);
	ws_config.linkPost();
};

ws_config.linkDelete = function(){
	var selected = $('#configSite select option:selected');
	if($(selected).length > 0){
		$(selected).remove();
	}
	ws_config.linkPost();
};

ws_config.linkPost = function()
{
	var xml = _ws.xml;
	xml+= "<externalLinks>\n";
	$('#configSite select option').each( function(){
		xml+="<item label=\""+encodeURIComponent($(this).text())+"\" data=\""+encodeURIComponent($(this).val())+"\" window=\""+$(this).attr("window")+"\"></item>\n";
	});
	xml+= "</externalLinks>\n";
	ws_util.logMessage(xml);
	if(xml!=''){
		ws_util.post(xml,"Saved","Failed to Save Links");
	}
};

ws_config.loadUsers = function()
{
	var select = $('#configUserManagement select:first');
	//$(select).empty();
	$.get("/gui/users.xml", function (data){
		$(data).find('user').each( function(){
			var user = $(this).find('name').text();
			var fullname = $(this).find('fullName').text();
			if(fullname == "")fullname=user;
			if(user != "admin"){
				var node = $('#configUserManagement select option[value="'+user+'"]');
				if($(node).length > 0){
					$(node).text(fullname);
				}else{
					option = '<option value="'+user+'">'+fullname+'</option>';
					$(select).append(option);
				}
			}
		});
	});
};

ws_config.initializeUserFields = function()
{
	var form=$('#editUser');
	$(form).find('input:eq(0)').attr("readonly","readonly");
	$(form).find('input:eq(0),input:eq(1),input:eq(2), select').val('');
	$(form).find('input:eq(3)').val('######');
	$(form).find('input:eq(4)').val('******');
	$(form).find('input:eq(5), input:eq(6)').removeAttr("checked");
};

ws_config.userNew = function()
{
	var form=$('#editUser');
	$(form).hide();
	ws_config.initializeUserFields();
	$(form).find('input:eq(0)').removeAttr('readonly');
	$(form).find('input:eq(5)').attr("checked",true);
	$(form).show();
};

ws_config.userEdit = function()
{
	var form=$('#editUser');
	$(form).hide();
	ws_config.initializeUserFields();
	var selected = $('#configUserManagement select :selected');
	if($(selected).length > 0){
		$.get("/gui/users.xml?user="+$(selected).val(), function (data){
			$(form).find('input:eq(0)').val($(data).find('name').text());
			$(form).find('input:eq(1)').val($(data).find('fullName').text());
			$(form).find('select').val($(data).find('permissions').text());
			$(form).find('input:eq(2)').val($(data).find('email').text());
			if($(data).find('enabled').text() == "true"){
				$(form).find('input:eq(5)').attr("checked",true);
			}
			if($(data).find('lockOut').text() == "true"){
				$(form).find('input:eq(6)').attr("checked",true);
			}
			$(form).show();
		});
	}
};

ws_config.userSave = function()
{
	var form=$('#editUser');
	var pass1 = $(form).find('input:eq(3)').val();
	var pass2 = $(form).find('input:eq(4)').val();
	if(pass1 != pass2 && (pass1 != "######" || pass2 != "******")){
		ws_util.messageDialog("Password Error", "Passwords must match!");
		return;
	}
	var xml = _ws.xml;
	xml+="<updateUser>\n";
	xml+="\t<name>"+$(form).find('input:eq(0)').val()+"</name>\n";
	xml+="\t<fullName>"+$(form).find('input:eq(1)').val()+"</fullName>\n";
	xml+="\t<email>"+$(form).find('input:eq(2)').val()+"</email>\n";
	xml+="\t<permissions>"+$(form).find('select').val()+"</permissions>\n";
	xml+="\t<enabled>"+($(form).find('input:eq(5)').attr("checked") != undefined)+"</enabled>\n";
	xml+="\t<lockOut>"+($(form).find('input:eq(6)').attr("checked") != undefined)+"</lockOut>\n";
	if(pass1 != "######" || pass2 != "******"){
		xml+="\t<pass1>"+pass1+"</pass1>\n";
		xml+="\t<pass2>"+pass2+"</pass2>\n";
	}
	xml+="</updateUser>";
	ws_util.logMessage(xml);
	ws_util.post(xml,"Saved","Failed to Save User",function(result){
		if(result){
			ws_config.loadUsers();
			$('#editUser').hide();
		}
	});
};

ws_config.userSaveMe = function()
{
	var form = $('#configUser');
	var xml = _ws.xml;
	xml+="<updateUser>\n";
	xml+="\t<name>"+$(form).find('input:eq(0)').val()+"</name>\n";
	xml+="\t<fullName>"+$(form).find('input:eq(1)').val()+"</fullName>\n";
	xml+="\t<email>"+$(form).find('input:eq(2)').val()+"</email>\n";
	xml+="</updateUser>";
	//ws_util.logMessage(xml);
	ws_util.post(xml,"Saved","Failed to Save User");
};

ws_config.userDelete = function()
{
	var form=$('#editUser');
	$(form).hide();
	ws_config.initializeUserFields();
	var selected = $('#configUserManagement select :selected');
	if($(selected).length > 0){
		var user = $(selected).val();
		var xml = _ws.xml;
		xml+= "<removeUser><name>"+user+"</name></removeUser>";
		ws_util.post(xml,"Saved","Failed",function(result){
			if(result){
				$('#configUserManagement select option[value="'+user+'"]').remove();
			}
		});
	}else{
		ws_util.messageDialog("User Delete", "Must select user first.");
	}
};

ws_config.changePassword = function()
{
	var cu = $('#configUser');
	var pass1 = $(cu).find('input:eq(4)').val();
	var pass2 = $(cu).find('input:eq(5)').val();
	if(pass1 != pass2 && !(pass1 == "######" && pass2 == "******")){
		ws_util.messageDialog("Password Error", "Passwords must match!");
		return;
	}
	$('#message-dialog').attr('title',"Change Password");
 	$('#message-dialog > p > span:eq(1)').text("Are you sure you want to change your password?");
 	$(function() {
 		$("#message-dialog").dialog({
 			height:200,
 			width:400,
 			modal: true,
 			buttons: {
	 			"Yes": function() {
		 			$(this).dialog('close');
		 			var xml = _ws.xml;
		 			xml+="<changePassword><user>"+$(cu).find('input:eq(0)').val()+"</user>";
		 			xml+="<pass1>"+$(cu).find('input:eq(4)').val()+"</pass1><pass2>"+$(cu).find('input:eq(5)').val()+"</pass2>";
		 			xml+="</changePassword>";
		 			ws_util.post(xml,"Saved","Failed to Change Password");
		 		},
		 		"No" : function() {
		 			$(this).dialog('close');
		 		}
	 		}
 		});
 	});
};

ws_config.verifyNetworkIds = function()
{
	$.get('/gui?q=VerifyNetworkIDs', function(data) {
	});
}
ws_technicianpages = {};

ws_technicianpages.toggleExportConfiguration = function() {
	_ws.exportConfiguration = !_ws.exportConfiguration;
	
	if(!_ws.exportConfiguration){
		ws_util.statusMessage("Disabled Bacnet Export Configuration",2000);		
	}else{
		ws_util.statusMessage("Enabled Bacnet Export Configuration",2000);		
	}
	
	ws_technicianpages.loadExportableItems();
		
};

ws_technicianpages.resetExportConfiguration = function() {
	$("#resetBacnetExportConfigurationDialog").html('This action will remove <b>ALL</b> previously exported items and cannot be undone. Proceed?').dialog( {
		buttons: [
		          { text: "Proceed", click: function() {		        	  	
		        	  	$(this).dialog("close");
		        	  	$.ajax({ 
		        	  		url: "/gui/?q=command&value=ResetBacnetExports", 
		        	  		success: function(thexml) {		        	  			
			        	  		$("#resetBacnetExportConfigurationDialog").text("All Export Table items have been removed.").dialog({
			        	  			title: 'Report',
			        	  			buttons: [ { text: 'Ok', click: function() {
			        	  				$(this).dialog("close");
			        	  				ws_technicianpages.loadExportableItems();
			        	  			} }]
			        	  		});
		        	  		}		        	  		
		        	  	});		        	  	
		        	  }
		          },
		          { text: "Cancel", click: function() {
		        	  	$(this).dialog("close");
		        	  } 
		          }
		          ],		
		title: "Are you sure?",		
	}				
	);	
};

ws_technicianpages.loadExportableItems = function() {
	
	$('#technicianSpinner').hide();
	if (_ws.exportConfiguration) {
		$('#technicianSpinner').show();
		$("#bacnetExportStatus").html('Enabled');
		$.get('/gui/bacnetExports.json', function(data) {
			aaData= []
			$.each(data, function(index,value) {
				aaData.push([ value['objectID'], value['control'], value['name'], value['status'], value['value'], value['ord'] ]);
			});
			$('#bacnetExportTable').show();
			$('#bacnetExportTable')
			.dataTable(
					{
						"bProcessing": true,						
						"bDestroy" : true,
		                "sDom" : 'T<"clear">lfrtip',
		                "oTableTools" : {
		                	"sSwfPath" : "/ord?file:^gui/media/swf/copy_csv_xls_pdf.swf"
		                },
		                "aaData": aaData,
		                "aoColumnDefs" : [
		                                  { "sWidth" : "1em", "aTargets": [ 3 ] }
		                ]
				});
			$('#technicianSpinner').hide();
		});
	} else {
		$('#bacnetExportTable').hide();				
		$("#bacnetExportStatus").html('Disabled');
	}
};
